/*--------------------------------------------------------------------------------------------------*/
/*	Function:  Sin Mobile Payment Series Application Programming Interface Function					*/
/* 	Version:   V1.1													   								*/
/*	Last Date: 2017.03.13																			*/
/* 	Author:    Anita										   										*/
/*--------------------------------------------------------------------------------------------------*/

/************************************************************************************/	
/* 	Include file																	*/
/************************************************************************************/
#include "stdafx.h"
#include "SinMPayApi.h"

/************************************************************************************/	
/* 	Public																			*/
/************************************************************************************/
#define SIN_TERMINAL_MAG_CARD_READ						"1B00021011"
#define SIN_TERMINAL_GET_VERSION						"1B00022521"
#define SIN_TERMINAL_GET_READER_SN						"1B00022524"
#define SIN_TERMINAL_SET_READER_SN						"1B00002525"
#define SIN_TERMINAL_GIVE_UP_ACTION						"1B00022527"

#define SIN_TERMIANL_ICC_SELECT_ICC						"1B0003253400"
#define SIN_TERMIANL_ICC_SELECT_SAM1					"1B0003253401"
#define SIN_TERMIANL_ICC_DETECT							"1B00022535"
#define SIN_TERMINAL_ICC_POWER_ON						"1B00022536"
#define SIN_TERMINAL_ICC_POWER_OFF						"1B00022537"
#define SIN_TERMINAL_ICC_ACCESS							"1B00002538"
#define SIN_TERMINAL_ICC_GET_CARDHOLDER_INFO			"1B00022540"
#define SIN_TERMINAL_ICC_GET_TRACK2_DATA				"1B00022543"

#define SIN_TERMINAL_MEMORY_SELECT_SLE4442				"1B0003260002"
#define SIN_TERMINAL_MEMORY_SELECT_SLE4428				"1B0003260004"
#define SIN_TERMINAL_MEMORY_SELECT_AT24C01				"1B000326000A"
#define SIN_TERMINAL_MEMORY_SELECT_AT24C02				"1B000326000B"
#define SIN_TERMINAL_MEMORY_SELECT_AT24C04				"1B000326000C"
#define SIN_TERMINAL_MEMORY_SELECT_AT24C08				"1B000326000D"
#define SIN_TERMINAL_MEMORY_SELECT_AT24C16				"1B000326000E"
#define SIN_TERMINAL_MEMORY_SELECT_AT24C32				"1B0003260013"
#define SIN_TERMINAL_MEMORY_SELECT_AT24C64				"1B0003260014"
#define SIN_TERMINAL_MEMORY_POWER_ON					"1B00022601"
#define SIN_TERMINAL_MEMORY_GET_CARD_TYPE				"1B00022602"
#define SIN_TERMINAL_MEMORY_READ_DATA					"1B00052603"
#define SIN_TERMINAL_MEMORY_WRITE_DATA					"1B00002604"
#define SIN_TERMINAL_MEMORY_POWER_OFF					"1B00022605"
#define SIN_TERMINAL_MEMORY_READ_ERROR_COUNTER			"1B00052607000001"
#define SIN_TERMINAL_MEMORY_VERIFY_PSC					"1B000026080000"
#define SIN_TERMINAL_MEMORY_GET_PSC						"1B000526090000"
#define SIN_TERMINAL_MEMORY_MODIFY_PSC					"1B0000260A0000"
#define SIN_TERMINAL_MEMORY_READ_DATA_WITH_PROTECT_BIT	"1B00052700"
#define SIN_TERMINAL_MEMORY_WRITE_DATA_WITH_PROTECT_BIT	"1B00002701"
#define SIN_TERMINAL_MEMORY_READ_PROTECTION_DATA		"1B00022800"
#define SIN_TERMINAL_MEMORY_WRITE_PROTECTION_DATA		"1B00002801"

#define SIN_TERMINAL_PICC_ACTIVATE						"1B00023511"
#define SIN_TERMINAL_PICC_DEACTIVATE					"1B00023512"
#define SIN_TERMINAL_PICC_RATS							"1B00023513"
#define SIN_TERMINAL_PICC_ACCESS						"1B00003514"

#define SIN_TERMINAL_MIFARE_AUTH						"1B00003515"
#define SIN_TERMINAL_MIFARE_READ_BLOCK					"1B00033516"
#define SIN_TERMINAL_MIFARE_WRITE_BLOCK					"1B00003517"
#define SIN_TERMINAL_MIFARE_INCREMENT					"1B00073518"
#define SIN_TERMINAL_MIFARE_DECREMENT					"1B00073519"



/************************************************************************************/	
/* 	Function																		*/
/************************************************************************************/
//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_GetApiVersion											//
// Description    : Get API's version.												//
// Input          : None															//
// Output         : Version: API's version string.									//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_GetApiVersion(LPSHStruct psh, CString *Version)
{
	*Version = _T("Sin mPay Series API Function V1.1");
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_DataComming												//
// Description    : Get device response data. (for asynchronous)					//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : None															//
// Return         : None															//
//////////////////////////////////////////////////////////////////////////////////////
VOID SinMPay_DataComming(LPSHStruct psh, Interface_TYPE Type)
{
//	int iDataLen = 0;
//	INT i = 0;
//	CString nStr = _T("");
//	psh->csDataComming = _T("");

	if (Type == Type_HID)
	{
		if (psh->byCmdReadBuffer[0] == 0x00 && psh->byCmdReadBuffer[1] == 0xA1) {
			::SendMessage(psh->hTargetWnd, WM_TERMINAL_RETURN_MAG_CARD_READ, 0, 0);
		}
		// Data comming
	/*	else
		{
			// SW = 0x00 (PASS)
			if (psh->byCmdReadBuffer[0] == 0x00)
			{
				// 1C 00 01 00 CRC
				if (psh->dwCmdReadLength == 1)
				{
					psh->csDataComming = _T("--> Data Comming !!");
					psh->csDataComming = psh->csDataComming + TCHAR(13) + TCHAR(10);
					psh->csDataComming += _T("Response : Success !!");
				}
				// 1C HLen LLen SW Data CRC
				else
				{
					psh->csDataComming = _T("--> Data Comming !!");
					psh->csDataComming = psh->csDataComming + TCHAR(13) + TCHAR(10);
					psh->csDataComming += _T("Response : ");
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						psh->csDataComming += nStr;
					}
				}
			}
			// SW: (Error)(psh->byCmdReadBuffer[0] == 0x01) or the other
			// 1C 00 01 SW CRC
			else
			{
				psh->csDataComming = _T("--> Data Comming !!");
				psh->csDataComming = psh->csDataComming + TCHAR(13) + TCHAR(10);
				psh->csDataComming += _T("  Response : SW = 0x");
				nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[0]);
				psh->csDataComming += nStr;
			}
			::SendMessage(psh->hTargetWnd, WM_DATACOMING, 0, 0);
		}*/
	}
	if (Type == Type_COM)
	{
		if (psh->byCmdReadBuffer[0] == 0x1C && psh->byCmdReadBuffer[3] == 0x00 && psh->byCmdReadBuffer[4] == 0xA1) {
			::SendMessage(psh->hTargetWnd, WM_TERMINAL_RETURN_MAG_CARD_READ, 0, 0);
		}
		// Data comming
	/*	else
		{
			int iDataLen = 0;
			INT i = 0;
			CString nStr = _T("");
			psh->csDataComming = _T("");
			// SW = 0x00 (PASS)
			if ((psh->byCmdReadBuffer[0] == 0x1C) && (psh->byCmdReadBuffer[3] == 0x00))
			{
				// 1C 00 01 00 CRC
				if (psh->byCmdReadBuffer[2] == 1)
				{
					psh->csDataComming = _T("--> Data Comming !!");
					psh->csDataComming = psh->csDataComming + TCHAR(13) + TCHAR(10);
					psh->csDataComming += _T("Response : Success !!");
				}
				// 1C HLen LLen SW Data CRC
				else
				{
					psh->csDataComming = _T("--> Data Comming !!");
					psh->csDataComming = psh->csDataComming + TCHAR(13) + TCHAR(10);
					psh->csDataComming += _T("Response : ");
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						psh->csDataComming += nStr;
					}
				}
			}
			// SW: (Error)(psh->byCmdReadBuffer[0] == 0x01)
			// 1C 00 01 SW CRC
			if ((psh->byCmdReadBuffer[0] == 0x1C) && (psh->byCmdReadBuffer[2] == 0x01))
			{
				psh->csDataComming = _T("--> Data Comming !!");
				psh->csDataComming = psh->csDataComming + TCHAR(13) + TCHAR(10);
				psh->csDataComming += _T("  Response : SW = 0x");
				nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[3]);
				psh->csDataComming += nStr;
			}
			::SendMessage(psh->hTargetWnd, WM_DATACOMING, 0, 0);
		}*/
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : String2Byte																		//
// Description    : String translate to Char and save to command buffer.							//
// Input          : start_of_szCmdBuffer: Command buffer's index, start to save translation data.	//
//					s: Strings for translation.														//
// Output         : szCmdBuffer: Save translation data. 											//
// Return         : None																			//
//////////////////////////////////////////////////////////////////////////////////////////////////////
void String2Byte(BYTE * szCmdBuffer, int start_of_szCmdBuffer, CString s)
{
	int i = 0;
	int len = s.GetLength() + 1;

	for (i = 0; i < len; i++)
		szCmdBuffer[start_of_szCmdBuffer + i] = s.GetAt(i) & 0x00FF; //mask first byte
}

//***** API Function *****//
//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_GetMagCardData											//
// Description    : Get magnetic card's data.										//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_GetMagCardData(LPSHStruct psh, Interface_TYPE Type)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MAG_CARD_READ, sizeof(SIN_TERMINAL_MAG_CARD_READ));
	BOOL bSuccess = FALSE;
	if (Type == Type_HID)
	{
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
	}
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_GetTerminalVersion										//
// Description    : Get terminal's version.											//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Version: Version string.										//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_GetTerminalVersion(LPSHStruct psh, Interface_TYPE Type, CString *Version)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_GET_VERSION, sizeof(SIN_TERMINAL_GET_VERSION));
	
	BOOL bSuccess = FALSE;
	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%c"), psh->byCmdReadBuffer[i + 1]);
						*Version += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i<iDataLen; i++)	{
						nStr.Format(_T("%c"), psh->byCmdReadBuffer[i + 4]);
						*Version += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_GetReaderSerialNumber									//
// Description    : Get reader's serial number.										//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : SerialNo: Reader's serial number.								//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_GetReaderSerialNumber(LPSHStruct psh, Interface_TYPE Type, CString *SerialNo)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_GET_READER_SN, sizeof(SIN_TERMINAL_GET_READER_SN));

	BOOL bSuccess = FALSE;
	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%c"), psh->byCmdReadBuffer[i + 1]);
						*SerialNo += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(100);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i<iDataLen; i++)	{
						nStr.Format(_T("%c"), psh->byCmdReadBuffer[i + 4]);
						*SerialNo += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_SetReaderSerialNumber									//
// Description    : Write serial number into reader.								//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					SerialNo: Reader's serial number.(must be 16 characters)		//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_SetReaderSerialNumber(LPSHStruct psh, Interface_TYPE Type, CString SerialNo)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_SET_READER_SN, sizeof(SIN_TERMINAL_SET_READER_SN));

	if (SerialNo.GetLength() != 0x10)	return FALSE;	//must be 16 characters
	String2Byte(psh->byCmdWriteBuffer, 10, SerialNo);

	INT iComLen = SerialNo.GetLength() + 2;
	INT iComLenL = iComLen & 0xFF;

	if (iComLenL / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x37;
	else						psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x30;
	if (iComLenL % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x37;
	else						psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, TRUE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, TRUE);
		if (bSuccess) {
			Sleep(300);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_GiveUpAction											//
// Description    : Cancel operation.												//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_GiveUpAction(LPSHStruct psh, Interface_TYPE Type)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_GIVE_UP_ACTION, sizeof(SIN_TERMINAL_GIVE_UP_ACTION));
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_IccSelectCard_X											//
// Description    : Select IC card's type.											//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					Samx: Set IC card's type.										//
//						 0x00: Smart card (default)									//
//						 0x01: SAM card 1											//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_IccSelectCard_X(LPSHStruct psh, Interface_TYPE Type, INT Samx)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	switch (Samx)
	{
	case 0:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMIANL_ICC_SELECT_ICC, sizeof(SIN_TERMIANL_ICC_SELECT_ICC));
		break;
	case 1:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMIANL_ICC_SELECT_SAM1, sizeof(SIN_TERMIANL_ICC_SELECT_SAM1));
		break;
	default:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMIANL_ICC_SELECT_ICC, sizeof(SIN_TERMIANL_ICC_SELECT_ICC));
		break;
	}
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_IccDetect												//
// Description    : Check card insert.												//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : isInserted: 													//
//								True: Card inserted.								//
//								False: Not insert.									//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_IccDetect(LPSHStruct psh, Interface_TYPE Type, BOOL *isInserted)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMIANL_ICC_DETECT, sizeof(SIN_TERMIANL_ICC_DETECT));
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					*isInserted = psh->byCmdReadBuffer[1];
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x02) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				*isInserted = psh->byCmdReadBuffer[4];
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_IccPowerOn												//
// Description    : IC card power-on and reset.										//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Atr: Get IC card's ATR(answer to reset) values.					//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_IccPowerOn(LPSHStruct psh, Interface_TYPE Type, CString *Atr)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_ICC_POWER_ON, sizeof(SIN_TERMINAL_ICC_POWER_ON));
	BOOL bSuccess = FALSE;
	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Atr += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(500);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {

					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Atr += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_IccPowerOff												//
// Description    : Power-off IC card.												//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_IccPowerOff(LPSHStruct psh, Interface_TYPE Type)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_ICC_POWER_OFF, sizeof(SIN_TERMINAL_ICC_POWER_OFF));
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(500);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;	
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_IccAccess												//
// Description    : Send APDU to IC card, and then get response APDU.				//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					Capdu: Write APDU command.										//
// Output         : Rapdu: Read response APDU.										//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_IccAccess(LPSHStruct psh, Interface_TYPE Type, CString Capdu, CString *Rapdu)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_ICC_ACCESS, sizeof(SIN_TERMINAL_ICC_ACCESS));

	String2Byte(psh->byCmdWriteBuffer, 10, Capdu);

	INT iComLen = (4 + Capdu.GetLength()) / 2;
	INT iComLenL = iComLen & 0xFF;
	INT iComLenH = (iComLen >> 8) & 0xFF;

	if( iComLenH/16 > 0xa )	psh->byCmdWriteBuffer[2] = iComLenH/16 + 0x37;
	else					psh->byCmdWriteBuffer[2] = iComLenH/16 + 0x30;
	if( iComLenH%16 > 0xa )	psh->byCmdWriteBuffer[3] = iComLenH%16 + 0x37;
	else					psh->byCmdWriteBuffer[3] = iComLenH%16 + 0x30;
	if( iComLenL/16 > 0xa )	psh->byCmdWriteBuffer[4] = iComLenL/16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLenL/16 + 0x30;
	if( iComLenL%16 > 0xa )	psh->byCmdWriteBuffer[5] = iComLenL%16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLenL%16 + 0x30;

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Rapdu += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(1500);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {

					iDataLen = (psh->byCmdReadBuffer[1] * 256) + psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Rapdu += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_IccGetCardholderInfo									//
// Description    : Get smart card's holder information.							//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Pan: Account number.											//
//					Name: Card's holder name.										//
//					Exp: Expiration date.											//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_IccGetCardholderInfo(LPSHStruct psh, Interface_TYPE Type, CString *Pan, CString *Name, CString *Exp)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_ICC_GET_CARDHOLDER_INFO, sizeof(SIN_TERMINAL_ICC_GET_CARDHOLDER_INFO));

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	BOOL bCardholderName = FALSE;
	BOOL bPan = FALSE;
	BOOL bExpireDate = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					i = 1;
					do {
						if (psh->byCmdReadBuffer[i] == 0xA1) {
							i++;
							iDataLen--;
							bPan = TRUE;
							bCardholderName = FALSE;
							bExpireDate = FALSE;
						}
						if (psh->byCmdReadBuffer[i] == 0xB1) {
							i++;
							iDataLen--;
							bPan = FALSE;
							bCardholderName = TRUE;
							bExpireDate = FALSE;
						}
						if (psh->byCmdReadBuffer[i] == 0xC1) {
							i++;
							iDataLen--;
							bPan = FALSE;
							bCardholderName = FALSE;
							bExpireDate = TRUE;
						}

						if (bPan) {
							nStr.Format(_T("%c"), psh->byCmdReadBuffer[i]);
							*Pan += nStr;
						}
						if (bCardholderName) {
							nStr.Format(_T("%c"), psh->byCmdReadBuffer[i]);
							*Name += nStr;
						}
						if (bExpireDate) {
							nStr.Format(_T("%c"), psh->byCmdReadBuffer[i]);
							*Exp += nStr;
						}
						i++;
						iDataLen--;
					} while (iDataLen > 0);
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(1700);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					i = 4;
					do {
						if (psh->byCmdReadBuffer[i] == 0xA1) {
							i++;
							iDataLen--;
							bPan = TRUE;
							bCardholderName = FALSE;
							bExpireDate = FALSE;
						}
						if (psh->byCmdReadBuffer[i] == 0xB1) {
							i++;
							iDataLen--;
							bPan = FALSE;
							bCardholderName = TRUE;
							bExpireDate = FALSE;
						}
						if (psh->byCmdReadBuffer[i] == 0xC1) {
							i++;
							iDataLen--;
							bPan = FALSE;
							bCardholderName = FALSE;
							bExpireDate = TRUE;
						}

						if (bPan) {
							nStr.Format(_T("%c"), psh->byCmdReadBuffer[i]);
							*Pan += nStr;
						}
						if (bCardholderName) {
							nStr.Format(_T("%c"), psh->byCmdReadBuffer[i]);
							*Name += nStr;
						}
						if (bExpireDate) {
							nStr.Format(_T("%c"), psh->byCmdReadBuffer[i]);
							*Exp += nStr;
						}
						i++;
						iDataLen--;
					} while (iDataLen > 0);
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_IccGetTrack2Data										//
// Description    : Get smart card's track 2 data.									//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Track2Data: Show the card's track 2 data.						//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_IccGetTrack2Data(LPSHStruct psh, Interface_TYPE Type, CString *Track2Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_ICC_GET_TRACK2_DATA, sizeof(SIN_TERMINAL_ICC_GET_TRACK2_DATA));

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%c"), psh->byCmdReadBuffer[i + 1]);
						*Track2Data += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(1700);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%c"), psh->byCmdReadBuffer[i + 4]);
						*Track2Data += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemorySelectCardType									//
// Description    : Select memory card's type.										//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					CardType: Set memory card's type.								//
//						 0x02: SLE4442												//
//						 0x04: SLE4428												//
//						 0x0A: AT24C01												//
//						 0x0B: AT24C02												//
//						 0x0C: AT24C04												//
//						 0x0D: AT24C08												//
//						 0x0E: AT24C16												//
//						 0x13: AT24C32												//
//						 0x14: AT24C64												//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemorySelectCardType(LPSHStruct psh, Interface_TYPE Type, INT CardType)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	switch (CardType)
	{
	case 0x02:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_SLE4442, sizeof(SIN_TERMINAL_MEMORY_SELECT_SLE4442));
		break;
	case 0x04:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_SLE4428, sizeof(SIN_TERMINAL_MEMORY_SELECT_SLE4428));
		break;
	case 0x0A:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_AT24C01, sizeof(SIN_TERMINAL_MEMORY_SELECT_AT24C01));
		break;
	case 0x0B:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_AT24C02, sizeof(SIN_TERMINAL_MEMORY_SELECT_AT24C02));
		break;
	case 0x0C:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_AT24C04, sizeof(SIN_TERMINAL_MEMORY_SELECT_AT24C04));
		break;
	case 0x0D:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_AT24C08, sizeof(SIN_TERMINAL_MEMORY_SELECT_AT24C08));
		break;
	case 0x0E:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_AT24C16, sizeof(SIN_TERMINAL_MEMORY_SELECT_AT24C16));
		break;
	case 0x13:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_AT24C32, sizeof(SIN_TERMINAL_MEMORY_SELECT_AT24C32));
		break;
	case 0x14:
		memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_SELECT_AT24C64, sizeof(SIN_TERMINAL_MEMORY_SELECT_AT24C64));
		break;
	default:
		return FALSE;
		break;
	}
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(500);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryPowerOn											//
// Description    : Memory card power-on and reset.									//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Atr: Get memory card's ATR values.(SLE4442/SLE4428 have ATR.)	//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryPowerOn(LPSHStruct psh, Interface_TYPE Type, CString *Atr)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_POWER_ON, sizeof(SIN_TERMINAL_MEMORY_POWER_ON));

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Atr += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(100);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Atr += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryGetCardType										//
// Description    : Get memory card's type.											//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : CardType: Get memory card's type.								//
//						 0x02: SLE4442												//
//						 0x04: SLE4428												//
//						 0x0A: AT24C01												//
//						 0x0B: AT24C02												//
//						 0x0C: AT24C04												//
//						 0x0D: AT24C08												//
//						 0x0E: AT24C16												//
//						 0x13: AT24C32												//
//						 0x14: AT24C64												//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryGetCardType(LPSHStruct psh, Interface_TYPE Type, INT *CardType)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_GET_CARD_TYPE, sizeof(SIN_TERMINAL_MEMORY_GET_CARD_TYPE));
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					*CardType = psh->byCmdReadBuffer[1];
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x02) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				*CardType = psh->byCmdReadBuffer[4];
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryReadData												//
// Description    : Read memory card's data.											//
// Input          : Type: Select interface type.										//
//						 Type_HID: Use for HID device.									//
//						 Type_COM: Use for Com port device.								//
//					Address: Set read memory card's start address.(String: 0000~FFFF)	//
//					Length: Read data length.(String: 01~FF)							//
// Output         : Data: Get memory card's data.										//
// Return         : True or False														//
//////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryReadData(LPSHStruct psh, Interface_TYPE Type, CString Address, CString Length, CString *Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_READ_DATA, sizeof(SIN_TERMINAL_MEMORY_READ_DATA));

	INT index = 10;
	if (Address.GetLength() != 4)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Address);
	index += 4;

	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Data += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(850);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = (psh->byCmdReadBuffer[1] * 256) + psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Data += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryWriteData												//
// Description    : Write data to memory card.											//
// Input          : Type: Select interface type.										//
//						 Type_HID: Use for HID device.									//
//						 Type_COM: Use for Com port device.								//
//					Address: Set write memory card's start address.(String: 0000~FFFF)	//
//					Length: Write data length.(String: 01~FF)							//
//					Data: Write data.(String: 1*2 ~ 255*2 words)						//
// Output         : None																//
// Return         : True or False														//
//////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryWriteData(LPSHStruct psh, Interface_TYPE Type, CString Address, CString Length, CString Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_WRITE_DATA, sizeof(SIN_TERMINAL_MEMORY_WRITE_DATA));

	INT index = 10;
	if (Address.GetLength() != 4)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Address);
	index += 4;

	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);
	index += 2;

	if (Data.GetLength() == 0)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Data);
	index += Data.GetLength();

	INT iComLen = (index - 6) / 2;
	INT iComLenL = iComLen & 0xFF;
	INT iComLenH = (iComLen >> 8) & 0xFF;

	if (iComLenH / 16 > 0xa)	psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x37;
	else						psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x30;
	if (iComLenH % 16 > 0xa)	psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x37;
	else						psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x30;
	if (iComLenL / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x37;
	else						psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x30;
	if (iComLenL % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x37;
	else						psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryPowerOff											//
// Description    : Power-off memory card.											//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryPowerOff(LPSHStruct psh, Interface_TYPE Type)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_POWER_OFF, sizeof(SIN_TERMINAL_MEMORY_POWER_OFF));
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(500);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryReadErrorCounter									//
// Description    : Read memory card's error counter. (for SLE4442/SLE4428)			//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : ErCount: Get memory card's error counter.						//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryReadErrorCounter(LPSHStruct psh, Interface_TYPE Type, CString *ErCount)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_READ_ERROR_COUNTER, sizeof(SIN_TERMINAL_MEMORY_READ_ERROR_COUNTER));

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*ErCount += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*ErCount += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryVerifyPsc											//
// Description    : Verify memory card's password. (for SLE4442/SLE4428)			//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					Length: PSC length.(SLE4442: 03)(SLE4428: 02)					//
//					Psc: Password.(SLE4442: 3*2 words)(SLE4428: 2*2 words)			//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryVerifyPsc(LPSHStruct psh, Interface_TYPE Type, CString Length, CString Psc)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_VERIFY_PSC, sizeof(SIN_TERMINAL_MEMORY_VERIFY_PSC));

	INT index = 14;
	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);
	index += 2;

	if (Psc.GetLength() == 0)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Psc);
	index += Psc.GetLength();

	INT iComLen = (index - 6) / 2;
	if (iComLen / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x30;
	if (iComLen % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryGetPsc											//
// Description    : Get memory card's password. (for SLE4442/SLE4428)				//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					Length: PSC length.(SLE4442: 03)(SLE4428: 02)					//
// Output         : Psc: Password.													//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryGetPsc(LPSHStruct psh, Interface_TYPE Type, CString Length, CString *Psc)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_GET_PSC, sizeof(SIN_TERMINAL_MEMORY_GET_PSC));

	INT index = 14;
	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Psc += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Psc += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryModifyPsc											//
// Description    : Modify memory card's password. (for SLE4442/SLE4428)			//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					Length: PSC length.(SLE4442: 03)(SLE4428: 02)					//
//					Psc: Password.(SLE4442: 3*2 words)(SLE4428: 2*2 words)			//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryModifyPsc(LPSHStruct psh, Interface_TYPE Type, CString Length, CString Psc)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_MODIFY_PSC, sizeof(SIN_TERMINAL_MEMORY_MODIFY_PSC));

	INT index = 14;
	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);
	index += 2;

	if (Psc.GetLength() == 0)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Psc);
	index += Psc.GetLength();

	INT iComLen = (index - 6) / 2;
	if (iComLen / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x30;
	if (iComLen % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryReadDataWithProtectBit								//
// Description    : Read memory card's data with protect bit. (for SLE4428)				//
// Input          : Type: Select interface type.										//
//						 Type_HID: Use for HID device.									//
//						 Type_COM: Use for Com port device.								//
//					Address: Set read memory card's start address.(String: 0000~FFFF)	//
//					Length: Read data length.(String: 01~FF)							//
// Output         : DataWithPb: Get memory card's data with protect bit.				//
// Return         : True or False														//
//////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryReadDataWithProtectBit(LPSHStruct psh, Interface_TYPE Type, CString Address, CString Length, CString *DataWithPb)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_READ_DATA_WITH_PROTECT_BIT, sizeof(SIN_TERMINAL_MEMORY_READ_DATA_WITH_PROTECT_BIT));

	INT index = 10;
	if (Address.GetLength() != 4)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Address);
	index += 4;

	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X "), psh->byCmdReadBuffer[i + 1]);
						*DataWithPb += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(200);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {

				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = (psh->byCmdReadBuffer[1] * 256) + psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*DataWithPb += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryWriteDataWithProtectBit								//
// Description    : Write memory card's data with protect bit. (for SLE4428)			//
// Input          : Type: Select interface type.										//
//						 Type_HID: Use for HID device.									//
//						 Type_COM: Use for Com port device.								//
//					Address: Set write memory card's start address.(String: 0000~FFFF)	//
//					Length: Write data length.(String: 01~FF)							//
//					Data: Write data.(String: 1*2 ~ 255*2 words)						//
// Output         : None																//
// Return         : True or False														//
//////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryWriteDataWithProtectBit(LPSHStruct psh, Interface_TYPE Type, CString Address, CString Length, CString Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_WRITE_DATA_WITH_PROTECT_BIT, sizeof(SIN_TERMINAL_MEMORY_WRITE_DATA_WITH_PROTECT_BIT));

	INT index = 10;
	if (Address.GetLength() != 4)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Address);
	index += 4;

	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);
	index += 2;

	if (Data.GetLength() == 0)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Data);
	index += Data.GetLength();

	INT iComLen = (index - 6) / 2;
	INT iComLenL = iComLen & 0xFF;
	INT iComLenH = (iComLen >> 8) & 0xFF;

	if (iComLenH / 16 > 0xa)	psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x37;
	else						psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x30;
	if (iComLenH % 16 > 0xa)	psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x37;
	else						psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x30;
	if (iComLenL / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x37;
	else						psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x30;
	if (iComLenL % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x37;
	else						psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryReadProtectionData								//
// Description    : Read memory card's Protection data. (for SLE4442)				//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Data: Get memory card's Protection data.						//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryReadProtectionData(LPSHStruct psh, Interface_TYPE Type, CString *Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_READ_PROTECTION_DATA, sizeof(SIN_TERMINAL_MEMORY_READ_PROTECTION_DATA));

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Data += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Data += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MemoryWriteProtectionData									//
// Description    : Write memory card's protection data. (for SLE4442)					//
// Input          : Type: Select interface type.										//
//						 Type_HID: Use for HID device.									//
//						 Type_COM: Use for Com port device.								//
//					Address: Set write memory card's start address.(String: 0000~001F)	//
//					Length: Write data length.(String: 01~FF)							//
//					Data: Write data.(String: 1*2 ~ 255*2 words)						//
// Output         : None																//
// Return         : True or False														//
//////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MemoryWriteProtectionData(LPSHStruct psh, Interface_TYPE Type, CString Address, CString Length, CString Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MEMORY_WRITE_PROTECTION_DATA, sizeof(SIN_TERMINAL_MEMORY_WRITE_PROTECTION_DATA));

	INT index = 10;
	if (Address.GetLength() != 4)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Address);
	index += 4;

	if (Length.GetLength() != 2)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Length);
	index += 2;

	if (Data.GetLength() == 0)	return FALSE;
	String2Byte(psh->byCmdWriteBuffer, index, Data);
	index += Data.GetLength();

	INT iComLen = (index - 6) / 2;
	INT iComLenL = iComLen & 0xFF;
	INT iComLenH = (iComLen >> 8) & 0xFF;

	if (iComLenH / 16 > 0xa)	psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x37;
	else						psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x30;
	if (iComLenH % 16 > 0xa)	psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x37;
	else						psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x30;
	if (iComLenL / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x37;
	else						psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x30;
	if (iComLenL % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x37;
	else						psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_PiccActivate											//
// Description    : Active RF card.													//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Cardno: RF card's number.										//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_PiccActivate(LPSHStruct psh, Interface_TYPE Type, CString *Cardno)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_PICC_ACTIVATE, sizeof(SIN_TERMINAL_PICC_ACTIVATE));
	BOOL bSuccess = FALSE;
	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					if (psh->byCmdReadBuffer[0] == 0x04)
					{
						*Cardno = _T("Timeout!!");
					}
					else
					{
						*Cardno = _T("Fail!!");
					}
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Cardno += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
		//	Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess)
			{
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Cardno += nStr;
					}
					bSuccess = TRUE;
				}
				else {
					if ((psh->byCmdReadBuffer[0] == 0x1C) &&
						(psh->byCmdReadBuffer[3] == 0x04)) {
						*Cardno = _T("Timeout!!");
					}
					else
					{
						*Cardno = _T("Fail!!");
					}
					bSuccess = FALSE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
/*	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_PICC_ACTIVATE, sizeof(SIN_TERMINAL_PICC_ACTIVATE));
	BOOL bSuccess = FALSE;
	if (Type == Type_HID)
	{
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
	}
	return (bSuccess ? TRUE : FALSE);*/
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_PiccDeactivate											//
// Description    : Stop RF card operation.											//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : None															//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_PiccDeactivate(LPSHStruct psh, Interface_TYPE Type)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_PICC_DEACTIVATE, sizeof(SIN_TERMINAL_PICC_DEACTIVATE));
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_PiccRats												//
// Description    : RF card activated and repond ATS.								//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
// Output         : Ats: Get RF card's ATS(answer to select) values.				//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_PiccRats(LPSHStruct psh, Interface_TYPE Type, CString *Ats)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_PICC_RATS, sizeof(SIN_TERMINAL_PICC_RATS));

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					if (iDataLen == 0)
						*Ats = _T("SW = 0x00, No Respond ATS!! ");
					else
					{
						for (i = 0; i < iDataLen; i++)
						{
							nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
							*Ats += nStr;
						}
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(500);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					if (iDataLen == 0)
						*Ats = _T("SW = 0x00, No Respond ATS!! ");
					else
					{
						for (i = 0; i < iDataLen; i++)
						{
							nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
							*Ats += nStr;
						}
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_PiccAccess												//
// Description    : Send APDU to RF card, and then get response APDU.				//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					Capdu: Write APDU command.										//
// Output         : Rapdu: Read response APDU.										//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_PiccAccess(LPSHStruct psh, Interface_TYPE Type, CString Capdu, CString *Rapdu)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_PICC_ACCESS, sizeof(SIN_TERMINAL_PICC_ACCESS));

	String2Byte(psh->byCmdWriteBuffer, 10, Capdu);

	INT iComLen = (4 + Capdu.GetLength()) / 2;
	INT iComLenL = iComLen & 0xFF;
	INT iComLenH = (iComLen >> 8) & 0xFF;

	if (iComLenH / 16 > 0xa)	psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x37;
	else					psh->byCmdWriteBuffer[2] = iComLenH / 16 + 0x30;
	if (iComLenH % 16 > 0xa)	psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x37;
	else					psh->byCmdWriteBuffer[3] = iComLenH % 16 + 0x30;
	if (iComLenL / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLenL / 16 + 0x30;
	if (iComLenL % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLenL % 16 + 0x30;

	CString nStr = _T("");
	int iDataLen = 0;
	INT i = 0;
	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Rapdu += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(1500);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = (psh->byCmdReadBuffer[1] * 256) + psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Rapdu += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MifareAuth														//
// Description    : Mifare card uses the corresponding key for the authentication.			//
// Input          : Type: Select interface type.											//
//						 Type_HID: Use for HID device.										//
//						 Type_COM: Use for Com port device.									//
//					KeyType: Select authentication key type.								//
//							 0x41: Key A													//
//							 0x42: Key B													//
//					Sector: Mifare card's memory location.									//
//							 0x00: Sector 0 ~ 0x0F: Sector 15								//
//					Key: The corresponding key for the authentication.(String: 6*2 words)	//
// Output         : None																	//
// Return         : True or False															//
//////////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MifareAuth(LPSHStruct psh, Interface_TYPE Type, INT KeyType, INT Sector, CString Key)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MIFARE_AUTH, sizeof(SIN_TERMINAL_MIFARE_AUTH));

	INT index = 10;
	BYTE tmp[2];
	tmp[0] = (KeyType & 0xF0) >> 4;
	tmp[1] = KeyType & 0x0F;
	if (tmp[0] < 0x0A)	psh->byCmdWriteBuffer[10] = tmp[0] + 0x30;
	else				psh->byCmdWriteBuffer[10] = tmp[0] + 0x37;
	if (tmp[1] < 0x0A)	psh->byCmdWriteBuffer[11] = tmp[1] + 0x30;
	else				psh->byCmdWriteBuffer[11] = tmp[1] + 0x37;
	index += 2;

	memset(tmp, 0, sizeof(tmp));
	tmp[0] = (Sector & 0xF0) >> 4;
	tmp[1] = Sector & 0x0F;
	if (tmp[0] < 0x0A)	psh->byCmdWriteBuffer[12] = tmp[0] + 0x30;
	else				psh->byCmdWriteBuffer[12] = tmp[0] + 0x37;
	if (tmp[1] < 0x0A)	psh->byCmdWriteBuffer[13] = tmp[1] + 0x30;
	else				psh->byCmdWriteBuffer[13] = tmp[1] + 0x37;
	index += 2;

	if (Key.GetLength() == 0) return FALSE;
	String2Byte(psh->byCmdWriteBuffer, 14, Key);
	index += Key.GetLength();

	INT iComLen = (index - 6) / 2;
	if (iComLen / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x30;
	if (iComLen % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MifareReadBlock											//
// Description    : Read mifare card's block after a successful authentication.		//
// Input          : Type: Select interface type.									//
//						 Type_HID: Use for HID device.								//
//						 Type_COM: Use for Com port device.							//
//					Block: Mifare card's memory location.(Sector * 4 + Block)		//
//							0x00: Sector 0, Block 0 ~ 0x3F: Sector 15, Block 3		//
// Output         : Data: The contents of a block of mifare card.					//
// Return         : True or False													//
//////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MifareReadBlock(LPSHStruct psh, Interface_TYPE Type, INT Block, CString *Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MIFARE_READ_BLOCK, sizeof(SIN_TERMINAL_MIFARE_READ_BLOCK));

	INT index = 10;
	int iDataLen = 0;
	INT i = 0;
	BYTE tmp[2];
	CString nStr = _T("");
	BOOL bSuccess = FALSE;
	
	tmp[0] = (Block & 0xF0) >> 4;
	tmp[1] = Block & 0x0F;
	if (tmp[0] < 0x0A)	psh->byCmdWriteBuffer[10] = tmp[0] + 0x30;
	else				psh->byCmdWriteBuffer[10] = tmp[0] + 0x37;
	if (tmp[1] < 0x0A)	psh->byCmdWriteBuffer[11] = tmp[1] + 0x30;
	else				psh->byCmdWriteBuffer[11] = tmp[1] + 0x37;

	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess)
			{
				// Check SW
				if (psh->byCmdReadBuffer[0] != 0x00) {
					bSuccess = FALSE;
				}
				else
				{
					iDataLen = psh->dwCmdReadLength - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 1]);
						*Data += nStr;
					}
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess) {
			Sleep(100);
			bSuccess = SinCom_Read(psh);
			if (bSuccess) {
				bSuccess = FALSE;
				if ((psh->byCmdReadBuffer[0] == 0x1C) &&
					(psh->byCmdReadBuffer[3] == 0x00)) {
					iDataLen = psh->byCmdReadBuffer[2] - 1;
					for (i = 0; i < iDataLen; i++)
					{
						nStr.Format(_T("%.2X"), psh->byCmdReadBuffer[i + 4]);
						*Data += nStr;
					}
					bSuccess = TRUE;
				}
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MifareWriteBlock												//
// Description    : Write mifare card's block after a successful authentication.			//
// Input          : Type: Select interface type.											//
//						 Type_HID: Use for HID device.										//
//						 Type_COM: Use for Com port device.									//
//					Block: Mifare card's memory location.(Sector * 4 + Block)				//
//							0x00: Sector 0, Block 0 ~ 0x3F: Sector 15, Block 3				//
//					Data: The contents of a block of mifare card.(String: 16*2 words)		//
// Output         : None																	//
// Return         : True or False															//
//////////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MifareWriteBlock(LPSHStruct psh, Interface_TYPE Type, INT Block, CString Data)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MIFARE_WRITE_BLOCK, sizeof(SIN_TERMINAL_MIFARE_WRITE_BLOCK));

	INT index = 10;
	BYTE tmp[2];
	tmp[0] = (Block & 0xF0) >> 4;
	tmp[1] = Block & 0x0F;
	if (tmp[0] < 0x0A)	psh->byCmdWriteBuffer[10] = tmp[0] + 0x30;
	else				psh->byCmdWriteBuffer[10] = tmp[0] + 0x37;
	if (tmp[1] < 0x0A)	psh->byCmdWriteBuffer[11] = tmp[1] + 0x30;
	else				psh->byCmdWriteBuffer[11] = tmp[1] + 0x37;
	index += 2;

	if (Data.GetLength() == 0) return FALSE;
	String2Byte(psh->byCmdWriteBuffer, 12, Data);
	index += Data.GetLength();

	INT iComLen = (index - 6) / 2;
	if (iComLen / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x30;
	if (iComLen % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(50);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MifareIncrement															//
// Description    : Increment value write to mifare card's block after a successful authentication.	//
// Input          : Type: Select interface type.													//
//						 Type_HID: Use for HID device.												//
//						 Type_COM: Use for Com port device.											//
//					Block: Mifare card's memory location.(Sector * 4 + Block)						//
//							0x00: Sector 0, Block 0 ~ 0x3F: Sector 15, Block 3						//
//					Value: The Increment value of mifare card's block.(String: 4*2 words)			//
// Output         : None																			//
// Return         : True or False																	//
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MifareIncrement(LPSHStruct psh, Interface_TYPE Type, INT Block, CString Value)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MIFARE_INCREMENT, sizeof(SIN_TERMINAL_MIFARE_INCREMENT));

	INT index = 10;
	BYTE tmp[2];
	tmp[0] = (Block & 0xF0) >> 4;
	tmp[1] = Block & 0x0F;
	if (tmp[0] < 0x0A)	psh->byCmdWriteBuffer[10] = tmp[0] + 0x30;
	else				psh->byCmdWriteBuffer[10] = tmp[0] + 0x37;
	if (tmp[1] < 0x0A)	psh->byCmdWriteBuffer[11] = tmp[1] + 0x30;
	else				psh->byCmdWriteBuffer[11] = tmp[1] + 0x37;
	index += 2;

	if (Value.GetLength() == 0) return FALSE;
	String2Byte(psh->byCmdWriteBuffer, 12, Value);
	index += Value.GetLength();

	INT iComLen = (index - 6) / 2;
	if (iComLen / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x30;
	if (iComLen % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(200);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Function Name  : SinMPay_MifareDecrement															//
// Description    : Decrement value write to mifare card's block after a successful authentication.	//
// Input          : Type: Select interface type.													//
//						 Type_HID: Use for HID device.												//
//						 Type_COM: Use for Com port device.											//
//					Block: Mifare card's memory location.(Sector * 4 + Block)						//
//							0x00: Sector 0, Block 0 ~ 0x3F: Sector 15, Block 3						//
//					Value: The Decrement value of mifare card's block.(String: 4*2 words)			//
// Output         : None																			//
// Return         : True or False																	//
//////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL SinMPay_MifareDecrement(LPSHStruct psh, Interface_TYPE Type, INT Block, CString Value)
{
	memset(psh->byCmdWriteBuffer, 0, sizeof(psh->byCmdWriteBuffer));
	memcpy(psh->byCmdWriteBuffer, SIN_TERMINAL_MIFARE_DECREMENT, sizeof(SIN_TERMINAL_MIFARE_DECREMENT));

	INT index = 10;
	BYTE tmp[2];
	tmp[0] = (Block & 0xF0) >> 4;
	tmp[1] = Block & 0x0F;
	if (tmp[0] < 0x0A)	psh->byCmdWriteBuffer[10] = tmp[0] + 0x30;
	else				psh->byCmdWriteBuffer[10] = tmp[0] + 0x37;
	if (tmp[1] < 0x0A)	psh->byCmdWriteBuffer[11] = tmp[1] + 0x30;
	else				psh->byCmdWriteBuffer[11] = tmp[1] + 0x37;
	index += 2;

	if (Value.GetLength() == 0) return FALSE;
	String2Byte(psh->byCmdWriteBuffer, 12, Value);
	index += Value.GetLength();

	INT iComLen = (index - 6) / 2;
	if (iComLen / 16 > 0xa)	psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x37;
	else					psh->byCmdWriteBuffer[4] = iComLen / 16 + 0x30;
	if (iComLen % 16 > 0xa)	psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x37;
	else					psh->byCmdWriteBuffer[5] = iComLen % 16 + 0x30;

	BOOL bSuccess = FALSE;
	psh->isOverlapped = FALSE;
	if (Type == Type_HID)
	{
		SinHid_SwitchReadHandle(psh, FALSE);
		bSuccess = SinHid_Write(psh, TRUE, FALSE);
		if (bSuccess)
		{
			bSuccess = SinHid_SingleRead(psh);
			if (bSuccess) {
				if (psh->byCmdReadBuffer[0] != 0x00)
				{
					bSuccess = FALSE;
				}
				else
				{
					bSuccess = TRUE;
				}
			}
		}
		SinHid_SwitchReadHandle(psh, TRUE);
	}
	if (Type == Type_COM)
	{
		PurgeComm(psh->hDeviceHandle, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
		bSuccess = SinCom_Write(psh, TRUE, FALSE);
		if (bSuccess)	{
			Sleep(200);
			bSuccess = SinCom_Read(psh);
			if (bSuccess && (psh->byCmdReadBuffer[0] == 0x1C) &&
				(psh->byCmdReadBuffer[2] == 0x01) &&
				(psh->byCmdReadBuffer[3] == 0x00)) {
				bSuccess = TRUE;
			}
			else {
				bSuccess = FALSE;
			}
		}
	}
	psh->isOverlapped = TRUE;
	return (bSuccess ? TRUE : FALSE);
}

/************************************************************************************/
/* 	History																			*/
/************************************************************************************/
/* SinMPayApi V1.0(2017.02.06)
1. from SinEmvL2Api and SinVcomEmvL2Api
2. HIDCOMX */

/* SinMPayApi V1.01(2017.02.14)
1. from SinMPayApi V1.0 
2. W[{ϥθT */

/* SinMPayApi V1.1(2017.03.13)
1. from SinMPayApi V1.01
2. W[Get/Set serial number function
3. SinMPay_PiccActivate()אּPB覡, tXϥtimer polling覡Ūd
4. Type_COM,̨Cfunction檬AקSleep()ɶ*/