// mPayMemoryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mPay.h"
#include "mPayMemoryDlg.h"
#include "afxdialogex.h"
#include "mPayDlg.h"

// mPayMemoryDlg dialog

IMPLEMENT_DYNAMIC(mPayMemoryDlg, CDialog)

mPayMemoryDlg::mPayMemoryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(mPayMemoryDlg::IDD, pParent)
{

}

mPayMemoryDlg::~mPayMemoryDlg()
{
}

void mPayMemoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_TEST, m_Ctrl_Test);
	DDX_Control(pDX, IDC_COMBO_CARDTYPE, m_Ctrl_CardType);
	DDX_Control(pDX, IDC_COMBO_SELECTITEM, m_Ctrl_SelectItem);
	DDX_Control(pDX, IDC_EDIT_ADDRESS, m_Ctrl_Address);
	DDX_Control(pDX, IDC_EDIT_LENGTH, m_Ctrl_Length);
	DDX_Control(pDX, IDC_EDIT_MEMORYACK, m_Ctrl_MemoryACK);
	DDX_Control(pDX, IDC_EDIT_MEMORYWRITEDATA, m_Ctrl_MemoryWriteData);
	DDX_Control(pDX, IDC_EDIT_PSC, m_Ctrl_PSC);
}


BEGIN_MESSAGE_MAP(mPayMemoryDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_CARDTYPE, &mPayMemoryDlg::OnCbnSelchangeComboCardtype)
	ON_CBN_SELCHANGE(IDC_COMBO_SELECTITEM, &mPayMemoryDlg::OnCbnSelchangeComboSelectitem)
	ON_BN_CLICKED(IDC_BUTTON_TEST, &mPayMemoryDlg::OnBnClickedButtonTest)
END_MESSAGE_MAP()


// mPayMemoryDlg message handlers


void mPayMemoryDlg::OnCbnSelchangeComboCardtype()
{
	// TODO: Add your control notification handler code here
	CmPayDlg *m_MainDlg = (CmPayDlg *)AfxGetMainWnd();

	BOOL bSuccess = FALSE;
	m_MainDlg->csMessage += _T("<-- Select Memory Card Type!!");
	m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
	m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
	switch (m_Ctrl_CardType.GetCurSel())
	{
	case 0:		//SLE4442
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Verify Secret Code"));
		m_Ctrl_SelectItem.AddString(_T("Read Error Counter"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Write Portection Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Portection Data"));
		m_Ctrl_SelectItem.AddString(_T("Write Security Code"));
		m_Ctrl_SelectItem.AddString(_T("Read Security Code"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x02);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x02);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select SLE4442 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select SLE4442 Fail!!");
		}
		break;
	case 1:		//SLE4428
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Verify Secret Code"));
		m_Ctrl_SelectItem.AddString(_T("Read Error Counter"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Write Data with Portect Bit"));
		m_Ctrl_SelectItem.AddString(_T("Read Data with Portect Bit"));
		m_Ctrl_SelectItem.AddString(_T("Write Security Code"));
		m_Ctrl_SelectItem.AddString(_T("Read Security Code"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x04);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x04);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select SLE4428 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select SLE4428 Fail!!");
		}
		break;
	case 2:		//AT24C01
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x0A);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x0A);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select AT24C01 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select AT24C01 Fail!!");
		}
		break;
	case 3:		//AT24C02
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x0B);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x0B);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select AT24C02 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select AT24C02 Fail!!");
		}
		break;
	case 4:		//AT24C04
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x0C);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x0C);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select AT24C04 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select AT24C04 Fail!!");
		}
		break;
	case 5:		//AT24C08
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x0D);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x0D);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select AT24C08 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select AT24C08 Fail!!");
		}
		break;
	case 6:		//AT24C16
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x0E);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x0E);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select AT24C16 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select AT24C16 Fail!!");
		}
		break;
	case 7:		//AT24C32
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x13);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x13);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select AT24C32 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select AT24C32 Fail!!");
		}
		break;
	case 8:		//AT24C64
		m_Ctrl_SelectItem.ResetContent();
		m_Ctrl_SelectItem.AddString(_T("Power On"));
		m_Ctrl_SelectItem.AddString(_T("Write Data"));
		m_Ctrl_SelectItem.AddString(_T("Read Data"));
		m_Ctrl_SelectItem.AddString(_T("Power Off"));
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_HID, 0x14);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemorySelectCardType(m_MainDlg->m_SinPsc, Type_COM, 0x14);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Select AT24C64 Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Select AT24C64 Fail!!");
		}
		break;
	}
	m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
	m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
	m_Ctrl_MemoryACK.LineScroll(m_Ctrl_MemoryACK.GetLineCount(), 0);
	m_Ctrl_SelectItem.SetCurSel(0);
	m_Ctrl_Address.SetWindowTextW(_T(""));
	m_Ctrl_Address.EnableWindow(FALSE);
	m_Ctrl_Length.SetWindowTextW(_T(""));
	m_Ctrl_Length.EnableWindow(FALSE);
	m_Ctrl_PSC.SetWindowTextW(_T(""));
	m_Ctrl_PSC.EnableWindow(FALSE);
	m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
	m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
}


void mPayMemoryDlg::OnCbnSelchangeComboSelectitem()
{
	// TODO: Add your control notification handler code here
	CmPayDlg *m_MainDlg = (CmPayDlg *)AfxGetMainWnd();

	switch (m_Ctrl_SelectItem.GetCurSel())
	{
	case 0:		//Power On
		m_Ctrl_Address.SetWindowTextW(_T(""));
		m_Ctrl_Address.EnableWindow(FALSE);
		m_Ctrl_Length.SetWindowTextW(_T(""));
		m_Ctrl_Length.EnableWindow(FALSE);
		m_Ctrl_PSC.SetWindowTextW(_T(""));
		m_Ctrl_PSC.EnableWindow(FALSE);
		m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
		m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		break;
	case 1:
		//SLE4442: Verify Secret Code
		if (m_Ctrl_CardType.GetCurSel() == 0)
		{
			m_Ctrl_Address.SetWindowTextW(_T("0000"));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T("03"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T("FFFFFF"));
			m_Ctrl_PSC.SetLimitText(6);
			m_Ctrl_PSC.EnableWindow(TRUE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		//SLE4428: Verify Secret Code
		else if (m_Ctrl_CardType.GetCurSel() == 1)
		{
			m_Ctrl_Address.SetWindowTextW(_T("0000"));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T("02"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T("FFFF"));
			m_Ctrl_PSC.SetLimitText(4);
			m_Ctrl_PSC.EnableWindow(TRUE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		//AT24CXX Series: Write Data
		else
		{
			m_Ctrl_Address.SetWindowTextW(_T("0084"));
			m_Ctrl_Address.SetLimitText(4);
			m_Ctrl_Address.EnableWindow(TRUE);		
			m_Ctrl_Length.SetWindowTextW(_T("02"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T(""));
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T("9876"));
			m_Ctrl_MemoryWriteData.EnableWindow(TRUE);
		}
		break;
	case 2:
		//SLE4442 or SLE4428: Read Error Counter
		if (m_Ctrl_CardType.GetCurSel() == 0 || m_Ctrl_CardType.GetCurSel() == 1)
		{
			m_Ctrl_Address.SetWindowTextW(_T("0000"));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T("01"));
			m_Ctrl_Length.EnableWindow(FALSE);
			m_Ctrl_PSC.SetWindowTextW(_T(""));
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		else	//AT24CXX Series: Read Data
		{
			m_Ctrl_Address.SetWindowTextW(_T("0084"));
			m_Ctrl_Address.SetLimitText(4);
			m_Ctrl_Address.EnableWindow(TRUE);
			m_Ctrl_Length.SetWindowTextW(_T("02"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T(""));
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		break;
	case 3:
		//SLE4442 or SLE4428: Write Data
		if (m_Ctrl_CardType.GetCurSel() == 0 || m_Ctrl_CardType.GetCurSel() == 1)
		{
			m_Ctrl_Address.SetWindowTextW(_T("0084"));
			m_Ctrl_Address.SetLimitText(4);
			m_Ctrl_Address.EnableWindow(TRUE);
			m_Ctrl_Length.SetWindowTextW(_T("02"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T(""));
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T("9876"));
			m_Ctrl_MemoryWriteData.EnableWindow(TRUE);
		}
		else	//AT24CXX Series: Power Off
		{
			m_Ctrl_Address.SetWindowTextW(_T(""));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T(""));
			m_Ctrl_Length.EnableWindow(FALSE);
			m_Ctrl_PSC.SetWindowTextW(_T(""));
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		break;
	case 4:		//SLE4442 or SLE4428: Read Data
		m_Ctrl_Address.SetWindowTextW(_T("0084"));
		m_Ctrl_Address.SetLimitText(4);
		m_Ctrl_Address.EnableWindow(TRUE);
		m_Ctrl_Length.SetWindowTextW(_T("02"));
		m_Ctrl_Length.SetLimitText(2);
		m_Ctrl_Length.EnableWindow(TRUE);
		m_Ctrl_PSC.SetWindowTextW(_T(""));
		m_Ctrl_PSC.EnableWindow(FALSE);
		m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		break;
	case 5:		//SLE4442 or SLE4428: Write Protection Data/Write Data with Portect bit
		m_Ctrl_Address.SetWindowTextW(_T("0011"));
		m_Ctrl_Address.SetLimitText(4);
		m_Ctrl_Address.EnableWindow(TRUE);
		m_Ctrl_Length.SetWindowTextW(_T("02"));
		m_Ctrl_Length.SetLimitText(2);
		m_Ctrl_Length.EnableWindow(TRUE);
		m_Ctrl_PSC.SetWindowTextW(_T(""));
		m_Ctrl_PSC.EnableWindow(FALSE);
		m_Ctrl_MemoryWriteData.SetWindowTextW(_T("5432"));
		m_Ctrl_MemoryWriteData.EnableWindow(TRUE);
		break;
	case 6:
		//SLE4442: Read Protection Data
		if (m_Ctrl_CardType.GetCurSel() == 0)
		{
			m_Ctrl_Address.SetWindowTextW(_T(""));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T(""));
			m_Ctrl_Length.EnableWindow(FALSE);
			m_Ctrl_PSC.SetWindowTextW(_T(""));
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		//SLE4428: Read Data with Portect bit
		else
		{
			m_Ctrl_Address.SetWindowTextW(_T("0011"));
			m_Ctrl_Address.SetLimitText(4);
			m_Ctrl_Address.EnableWindow(TRUE);
			m_Ctrl_Length.SetWindowTextW(_T("02"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T(""));
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		break;
	case 7:
		//SLE4442: Write Security Code
		if (m_Ctrl_CardType.GetCurSel() == 0)
		{
			m_Ctrl_Address.SetWindowTextW(_T("0000"));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T("03"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T("123456"));
			m_Ctrl_PSC.SetLimitText(6);
			m_Ctrl_PSC.EnableWindow(TRUE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		//SLE4428: Write Security Code
		else
		{
			m_Ctrl_Address.SetWindowTextW(_T("0000"));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T("02"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.SetWindowTextW(_T("1234"));
			m_Ctrl_PSC.SetLimitText(4);
			m_Ctrl_PSC.EnableWindow(TRUE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		break;
	case 8:
		//SLE4442: Read Security Code
		if (m_Ctrl_CardType.GetCurSel() == 0)
		{
			m_Ctrl_Address.SetWindowTextW(_T("0000"));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T("03"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		//SLE4428: Read Security Code
		else
		{
			m_Ctrl_Address.SetWindowTextW(_T("0000"));
			m_Ctrl_Address.EnableWindow(FALSE);
			m_Ctrl_Length.SetWindowTextW(_T("02"));
			m_Ctrl_Length.SetLimitText(2);
			m_Ctrl_Length.EnableWindow(TRUE);
			m_Ctrl_PSC.EnableWindow(FALSE);
			m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
			m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		}
		break;
	case 9:		//SLE4442 or SLE4428: Power Off
		m_Ctrl_Address.SetWindowTextW(_T(""));
		m_Ctrl_Address.EnableWindow(FALSE);
		m_Ctrl_Length.SetWindowTextW(_T(""));
		m_Ctrl_Length.EnableWindow(FALSE);
		m_Ctrl_PSC.SetWindowTextW(_T(""));
		m_Ctrl_PSC.EnableWindow(FALSE);
		m_Ctrl_MemoryWriteData.SetWindowTextW(_T(""));
		m_Ctrl_MemoryWriteData.EnableWindow(FALSE);
		break;
	}
}


void mPayMemoryDlg::OnBnClickedButtonTest()
{
	// TODO: Add your control notification handler code here
	CmPayDlg *m_MainDlg = (CmPayDlg *)AfxGetMainWnd();

	BOOL bSuccess = FALSE;
	CString csAddress = _T("");
	CString csLength = _T("");
	CString csPSC = _T("");
	CString csWriteData = _T("");
	CString csATR = _T("");
	CString csErrorCounter = _T("");
	CString csData = _T("");
	INT i = 0;
	switch (m_Ctrl_SelectItem.GetCurSel())
	{
	case 0:		//Power On
		m_MainDlg->csMessage += _T("<-- Select 'Power On' Test!!");
		m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
		m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemoryPowerOn(m_MainDlg->m_SinPsc, Type_HID, &csATR);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemoryPowerOn(m_MainDlg->m_SinPsc, Type_COM, &csATR);
		}
		if (bSuccess)
		{
			if (csATR == _T(""))	//Non-ATR
				m_MainDlg->csMessage += _T("--> Power On Test: Pass!!");
			else
			{
				m_MainDlg->csMessage += _T("--> Got ATR: ");
				m_MainDlg->csMessage += csATR;
			}
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Power On Test: Fail!!");
		}
		break;
	case 1:
		//SLE4442 or SLE4428: Verify Secret Code
		if ((m_Ctrl_CardType.GetCurSel() == 0) || (m_Ctrl_CardType.GetCurSel() == 1))
		{
			m_MainDlg->csMessage += _T("<-- Select 'Verify Secret Code' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if ((m_Ctrl_Length.GetWindowTextLengthW() != 0) && (m_Ctrl_PSC.GetWindowTextLengthW() != 0))
			{
				m_Ctrl_Length.GetWindowTextW(csLength);
				m_Ctrl_PSC.GetWindowTextW(csPSC);
				if (m_MainDlg->bHID)
				{
					bSuccess = SinMPay_MemoryVerifyPsc(m_MainDlg->m_SinPsc, Type_HID, csLength, csPSC);
				}
				if (m_MainDlg->bVCOM)
				{
					bSuccess = SinMPay_MemoryVerifyPsc(m_MainDlg->m_SinPsc, Type_COM, csLength, csPSC);
				}
				if (bSuccess)
				{
					m_MainDlg->csMessage += _T("--> Verify PSC Test: Pass!!");
				}
				else
				{
					m_MainDlg->csMessage += _T("--> Verify PSC Test: Fail!!");
				}
			}
			else
				m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Length' and 'PSC' edit box.");
		}
		//AT24CXX Series: Write Data
		else
		{
			m_MainDlg->csMessage += _T("<-- Select 'Write Data' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if ((m_Ctrl_Address.GetWindowTextLengthW() != 0) && (m_Ctrl_Length.GetWindowTextLengthW() != 0) && (m_Ctrl_MemoryWriteData.GetWindowTextLengthW() != 0))
			{
				m_Ctrl_Address.GetWindowTextW(csAddress);
				m_Ctrl_Length.GetWindowTextW(csLength);
				m_Ctrl_MemoryWriteData.GetWindowTextW(csWriteData);
				for (i = m_Ctrl_Address.GetWindowTextLengthW(); i<4; i++)
					csAddress = _T("0") + csAddress;
				m_Ctrl_Address.SetWindowTextW(csAddress);
				if (m_MainDlg->bHID)
				{
					bSuccess = SinMPay_MemoryWriteData(m_MainDlg->m_SinPsc, Type_HID, csAddress, csLength, csWriteData);
				}
				if (m_MainDlg->bVCOM)
				{
					bSuccess = SinMPay_MemoryWriteData(m_MainDlg->m_SinPsc, Type_COM, csAddress, csLength, csWriteData);
				}
				if (bSuccess)
				{
					m_MainDlg->csMessage += _T("--> Write Data Test: Pass!!");
				}
				else
				{
					m_MainDlg->csMessage += _T("--> Write Data Test: Fail!!");
				}
			}
			else
				m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Address', 'Length', and 'Write Data' edit box.");
		}
		break;
	case 2:
		//SLE4442 or SLE4428: Read Error Counter
		if (m_Ctrl_CardType.GetCurSel() == 0 || m_Ctrl_CardType.GetCurSel() == 1)
		{
			m_MainDlg->csMessage += _T("<-- Select 'Read Error Counter' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if (m_MainDlg->bHID)
			{
				bSuccess = SinMPay_MemoryReadErrorCounter(m_MainDlg->m_SinPsc, Type_HID, &csErrorCounter);
			}
			if (m_MainDlg->bVCOM)
			{
				bSuccess = SinMPay_MemoryReadErrorCounter(m_MainDlg->m_SinPsc, Type_COM, &csErrorCounter);
			}
			if (bSuccess)
			{
				m_MainDlg->csMessage += _T("--> Got Error Counter: ");
				m_MainDlg->csMessage += csErrorCounter;
			}
			else
			{
				m_MainDlg->csMessage += _T("--> Read Error Counter Test: Fail!!");
			}
		}
		else	//AT24CXX Series: Read Data
		{
			m_MainDlg->csMessage += _T("<-- Select 'Read Data' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if ((m_Ctrl_Address.GetWindowTextLengthW() != 0) && (m_Ctrl_Length.GetWindowTextLengthW() != 0))
			{
				m_Ctrl_Address.GetWindowTextW(csAddress);
				m_Ctrl_Length.GetWindowTextW(csLength);
				for (i = m_Ctrl_Address.GetWindowTextLengthW(); i<4; i++)
					csAddress = _T("0") + csAddress;
				m_Ctrl_Address.SetWindowTextW(csAddress);
				if (m_MainDlg->bHID)
				{
					bSuccess = SinMPay_MemoryReadData(m_MainDlg->m_SinPsc, Type_HID, csAddress, csLength, &csData);
				}
				if (m_MainDlg->bVCOM)
				{
					bSuccess = SinMPay_MemoryReadData(m_MainDlg->m_SinPsc, Type_COM, csAddress, csLength, &csData);
				}
				if (bSuccess)
				{
					m_MainDlg->csMessage += _T("--> Got Data: ");
					m_MainDlg->csMessage += csData;
				}
				else
				{
					m_MainDlg->csMessage += _T("--> Read Data Test: Fail!!");
				}
			}
			else
				m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Address' and 'Length' edit box.");
		}
		break;
	case 3:
		//SLE4442 or SLE4428: Write Data
		if (m_Ctrl_CardType.GetCurSel() == 0 || m_Ctrl_CardType.GetCurSel() == 1)
		{
			m_MainDlg->csMessage += _T("<-- Select 'Write Data' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if ((m_Ctrl_Address.GetWindowTextLengthW() != 0) && (m_Ctrl_Length.GetWindowTextLengthW() != 0) && (m_Ctrl_MemoryWriteData.GetWindowTextLengthW() != 0))
			{
				m_Ctrl_Address.GetWindowTextW(csAddress);
				m_Ctrl_Length.GetWindowTextW(csLength);
				m_Ctrl_MemoryWriteData.GetWindowTextW(csWriteData);
				for (i = m_Ctrl_Address.GetWindowTextLengthW(); i<4; i++)
					csAddress = _T("0") + csAddress;
				m_Ctrl_Address.SetWindowTextW(csAddress);
				if (m_MainDlg->bHID)
				{
					bSuccess = SinMPay_MemoryWriteData(m_MainDlg->m_SinPsc, Type_HID, csAddress, csLength, csWriteData);
				}
				if (m_MainDlg->bVCOM)
				{
					bSuccess = SinMPay_MemoryWriteData(m_MainDlg->m_SinPsc, Type_COM, csAddress, csLength, csWriteData);
				}
				if (bSuccess)
				{
					m_MainDlg->csMessage += _T("--> Write Data Test: Pass!!");
				}
				else
				{
					m_MainDlg->csMessage += _T("--> Write Data Test: Fail!!");
				}
			}
			else
				m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Address', 'Length', and 'Write Data' edit box.");
		}
		//AT24CXX Series: Power Off
		else
		{
			m_MainDlg->csMessage += _T("<-- Select 'Power Off' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if (m_MainDlg->bHID)
			{
				bSuccess = SinMPay_MemoryPowerOff(m_MainDlg->m_SinPsc, Type_HID);
			}
			if (m_MainDlg->bVCOM)
			{
				bSuccess = SinMPay_MemoryPowerOff(m_MainDlg->m_SinPsc, Type_COM);
			}
			if (bSuccess)
			{
				m_MainDlg->csMessage += _T("--> Power Off Test: Pass!!");
			}
			else
			{
				m_MainDlg->csMessage += _T("--> Power Off Test: Fail!!");
			}
		}
		break;
	case 4:		//SLE4442 or SLE4428: Read Data
		m_MainDlg->csMessage += _T("<-- Select 'Read Data' Test!!");
		m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
		m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
		if ((m_Ctrl_Address.GetWindowTextLengthW() != 0) && (m_Ctrl_Length.GetWindowTextLengthW() != 0))
		{
			m_Ctrl_Address.GetWindowTextW(csAddress);
			m_Ctrl_Length.GetWindowTextW(csLength);
			for (i = m_Ctrl_Address.GetWindowTextLengthW(); i<4; i++)
				csAddress = _T("0") + csAddress;
			m_Ctrl_Address.SetWindowTextW(csAddress);
			if (m_MainDlg->bHID)
			{
				bSuccess = SinMPay_MemoryReadData(m_MainDlg->m_SinPsc, Type_HID, csAddress, csLength, &csData);
			}
			if (m_MainDlg->bVCOM)
			{
				bSuccess = SinMPay_MemoryReadData(m_MainDlg->m_SinPsc, Type_COM, csAddress, csLength, &csData);
			}
			if (bSuccess)
			{
				m_MainDlg->csMessage += _T("--> Got Data: ");
				m_MainDlg->csMessage += csData;
			}
			else
			{
				m_MainDlg->csMessage += _T("--> Read Data Test: Fail!!");
			}
		}
		else
			m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Address' and 'Length' edit box.");
		break;
	case 5:
		//SLE4442: Write Protection Data
		if (m_Ctrl_CardType.GetCurSel() == 0)
		{
			m_MainDlg->csMessage += _T("<-- Select 'Write Protection Data' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if ((m_Ctrl_Address.GetWindowTextLengthW() != 0) && (m_Ctrl_Length.GetWindowTextLengthW() != 0) && (m_Ctrl_MemoryWriteData.GetWindowTextLengthW() != 0))
			{
				m_Ctrl_Address.GetWindowTextW(csAddress);
				m_Ctrl_Length.GetWindowTextW(csLength);
				m_Ctrl_MemoryWriteData.GetWindowTextW(csWriteData);
				for (i = m_Ctrl_Address.GetWindowTextLengthW(); i<4; i++)
					csAddress = _T("0") + csAddress;
				m_Ctrl_Address.SetWindowTextW(csAddress);
				if (m_MainDlg->bHID)
				{
					bSuccess = SinMPay_MemoryWriteProtectionData(m_MainDlg->m_SinPsc, Type_HID, csAddress, csLength, csWriteData);
				}
				if (m_MainDlg->bVCOM)
				{
					bSuccess = SinMPay_MemoryWriteProtectionData(m_MainDlg->m_SinPsc, Type_COM, csAddress, csLength, csWriteData);
				}
				if (bSuccess)
				{
					m_MainDlg->csMessage += _T("--> Write Protection Data Test: Pass!!");
				}
				else
				{
					m_MainDlg->csMessage += _T("--> Write Protection Data Test: Fail!!");
				}
			}
			else
				m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Address', 'Length', and 'Write Data' edit box.");
		}
		//SLE4428: Write Data with Portect Bit
		else
		{
			m_MainDlg->csMessage += _T("<-- Select 'Write Data with Portect Bit' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if ((m_Ctrl_Address.GetWindowTextLengthW() != 0) && (m_Ctrl_Length.GetWindowTextLengthW() != 0) && (m_Ctrl_MemoryWriteData.GetWindowTextLengthW() != 0))
			{
				m_Ctrl_Address.GetWindowTextW(csAddress);
				m_Ctrl_Length.GetWindowTextW(csLength);
				m_Ctrl_MemoryWriteData.GetWindowTextW(csWriteData);
				for (i = m_Ctrl_Address.GetWindowTextLengthW(); i<4; i++)
					csAddress = _T("0") + csAddress;
				m_Ctrl_Address.SetWindowTextW(csAddress);
				if (m_MainDlg->bHID)
				{
					bSuccess = SinMPay_MemoryWriteDataWithProtectBit(m_MainDlg->m_SinPsc, Type_HID, csAddress, csLength, csWriteData);
				}
				if (m_MainDlg->bVCOM)
				{
					bSuccess = SinMPay_MemoryWriteDataWithProtectBit(m_MainDlg->m_SinPsc, Type_COM, csAddress, csLength, csWriteData);
				}
				if (bSuccess)
				{
					m_MainDlg->csMessage += _T("--> Write Data with Portect Bit Test: Pass!!");
				}
				else
				{
					m_MainDlg->csMessage += _T("--> Write Data with Portect Bit Test: Fail!!");
				}
			}
			else
				m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Address', 'Length', and 'Write Data' edit box.");
		}
		break;
	case 6:
		//SLE4442: Read Protection Data
		if (m_Ctrl_CardType.GetCurSel() == 0)
		{
			m_MainDlg->csMessage += _T("<-- Select 'Read Protection Data' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if (m_MainDlg->bHID)
			{
				bSuccess = SinMPay_MemoryReadProtectionData(m_MainDlg->m_SinPsc, Type_HID, &csData);
			}
			if (m_MainDlg->bVCOM)
			{
				bSuccess = SinMPay_MemoryReadProtectionData(m_MainDlg->m_SinPsc, Type_COM, &csData);
			}
			if (bSuccess)
			{
				m_MainDlg->csMessage += _T("--> Got Protection Data: ");
				m_MainDlg->csMessage += csData;
			}
			else
			{
				m_MainDlg->csMessage += _T("--> Read Protection Data Test: Fail!!");
			}
		}
		//SLE4428: Read Data with Portect bit
		else
		{
			m_MainDlg->csMessage += _T("<-- Select 'Read Data with Portect Bit' Test!!");
			m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
			m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
			if ((m_Ctrl_Address.GetWindowTextLengthW() != 0) && (m_Ctrl_Length.GetWindowTextLengthW() != 0))
			{
				m_Ctrl_Address.GetWindowTextW(csAddress);
				m_Ctrl_Length.GetWindowTextW(csLength);
				for (i = m_Ctrl_Address.GetWindowTextLengthW(); i<4; i++)
					csAddress = _T("0") + csAddress;
				m_Ctrl_Address.SetWindowTextW(csAddress);
				if (m_MainDlg->bHID)
				{
					bSuccess = SinMPay_MemoryReadDataWithProtectBit(m_MainDlg->m_SinPsc, Type_HID, csAddress, csLength, &csData);
				}
				if (m_MainDlg->bVCOM)
				{
					bSuccess = SinMPay_MemoryReadDataWithProtectBit(m_MainDlg->m_SinPsc, Type_COM, csAddress, csLength, &csData);
				}
				if (bSuccess)
				{
					m_MainDlg->csMessage += _T("--> Got Data + Portect Bit: ");
					m_MainDlg->csMessage += csData;
				}
				else
				{
					m_MainDlg->csMessage += _T("--> Read Data with Portect Bit Test: Fail!!");
				}
			}
			else
				m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Address' and 'Length' edit box.");
		}
		break;
	case 7:
		//SLE4442 or SLE4428: Write Security Code
		m_MainDlg->csMessage += _T("<-- Select 'Write Security Code' Test!!");
		m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
		m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
		if ((m_Ctrl_Length.GetWindowTextLengthW() != 0) && (m_Ctrl_PSC.GetWindowTextLengthW() != 0))
		{
			m_Ctrl_Length.GetWindowTextW(csLength);
			m_Ctrl_PSC.GetWindowTextW(csPSC);
			if (m_MainDlg->bHID)
			{
				bSuccess = SinMPay_MemoryModifyPsc(m_MainDlg->m_SinPsc, Type_HID, csLength, csPSC);
			}
			if (m_MainDlg->bVCOM)
			{
				bSuccess = SinMPay_MemoryModifyPsc(m_MainDlg->m_SinPsc, Type_COM, csLength, csPSC);
			}
			if (bSuccess)
			{
				m_MainDlg->csMessage += _T("--> Modify PSC Test: Pass!!");
			}
			else
			{
				m_MainDlg->csMessage += _T("--> Modify PSC Test: Fail!!");
			}
		}
		else
			m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Length' and 'PSC' edit box.");
		break;
	case 8:
		//SLE4442 or SLE4428: Read Security Code
		m_MainDlg->csMessage += _T("<-- Select 'Read Security Code' Test!!");
		m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
		m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
		if (m_Ctrl_Length.GetWindowTextLengthW() != 0)
		{
			m_Ctrl_Length.GetWindowTextW(csLength);
			if (m_MainDlg->bHID)
			{
				bSuccess = SinMPay_MemoryGetPsc(m_MainDlg->m_SinPsc, Type_HID, csLength, &csPSC);
			}
			if (m_MainDlg->bVCOM)
			{
				bSuccess = SinMPay_MemoryGetPsc(m_MainDlg->m_SinPsc, Type_COM, csLength, &csPSC);
			}
			if (bSuccess)
			{
				m_MainDlg->csMessage += _T("--> Got PSC: ");
				m_MainDlg->csMessage += csPSC;
			}
			else
			{
				m_MainDlg->csMessage += _T("--> Get PSC Test: Fail!!");
			}
		}
		else
			m_MainDlg->csMessage += _T("--> Fail!! Please key-in data into 'Length' edit box.");
		break;
	case 9:		//SLE4442 or SLE4428: Power Off
		m_MainDlg->csMessage += _T("<-- Select 'Power Off' Test!!");
		m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
		m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
		if (m_MainDlg->bHID)
		{
			bSuccess = SinMPay_MemoryPowerOff(m_MainDlg->m_SinPsc, Type_HID);
		}
		if (m_MainDlg->bVCOM)
		{
			bSuccess = SinMPay_MemoryPowerOff(m_MainDlg->m_SinPsc, Type_COM);
		}
		if (bSuccess)
		{
			m_MainDlg->csMessage += _T("--> Power Off Test: Pass!!");
		}
		else
		{
			m_MainDlg->csMessage += _T("--> Power Off Test: Fail!!");
		}
		break;
	}
	m_MainDlg->csMessage = m_MainDlg->csMessage + TCHAR(13) + TCHAR(10);
	m_Ctrl_MemoryACK.SetWindowTextW(m_MainDlg->csMessage);
	m_Ctrl_MemoryACK.LineScroll(m_Ctrl_MemoryACK.GetLineCount(), 0);
}
