﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Import mPayVC6.dll services
using System.Runtime.InteropServices;

namespace Test
{
    public partial class Form1 : Form
    {
        // Import mPayVC6.dll API refer to the declaration in mPAY_VC6.h
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_Connect", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_Connect(int iComNo, int iHIDIndex);
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_Disconnect", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_Disconnect(int iHIDIndex);
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_GetTerminalVersion", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_GetTerminalVersion(StringBuilder sVersion); 

        [DllImport("mPayVC6.dll", EntryPoint = "mPay_ICCPowerOn", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_ICCPowerOn(StringBuilder ATR);
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_ICCPowerOff", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_ICCPowerOff();
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_ICCSendApdu", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_ICCSendApdu(string cmd, StringBuilder recv); 

        [DllImport("mPayVC6.dll", EntryPoint = "mPay_SAMPowerOn", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_SAMPowerOn(StringBuilder ATR); 
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_SAMPowerOff", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_SAMPowerOff();
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_SAMSendApdu", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_SAMSendApdu(string cmd, StringBuilder recv); 

        [DllImport("mPayVC6.dll", EntryPoint = "mPay_PICCActivate", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_PICCActivate(StringBuilder cardNo); 
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_PICCDeactivate", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_PICCDeactivate();
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_PICCGetCardATS", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_PICCGetCardATS(StringBuilder ATS);
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_PICCSendApdu", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_PICCSendApdu(string cmd, StringBuilder recv); 

        [DllImport("mPayVC6.dll", EntryPoint = "mPay_MifareAuth", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_MifareAuth(int KeyType, int Sector, string Key); 
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_MifareReadBlock", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_MifareReadBlock(int Block, StringBuilder ReadData); 
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_MifareWriteBlock", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_MifareWriteBlock(int Block, string WriteData); 
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_MifareIncrement", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_MifareIncrement(int Block, string Value); 
        [DllImport("mPayVC6.dll", EntryPoint = "mPay_MifareDecrement", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int mPay_MifareDecrement(int Block, string Value); 


        // [DllImport("c:\\Temp\\MY.dll", //*.EXE path, e.g. \Project\bin\Release
        // EntryPoint="mySum", //DLL entry point
        // CharSet=CharSet.Ansi ,  //CharSet: String format  
        // CallingConvention=CallingConvention.StdCall)], // API's calling convention (Default WINAPI)

        int iSelectCardType;
        string csMessage;

        public Form1()
        {
            InitializeComponent();
            cbPort.SelectedIndex = 0;
        }

        private void btConnect_Click(object sender, EventArgs e)
        {
            int nPort = 0;
            string s = "";
            int iSel = cbPort.SelectedIndex;

            switch (iSel)
            {
                case 0:		//Select AUTO-scan mode
                     nPort = mPay_Connect(0, 0);
                    if (nPort == -1)
                    {
                        lbPort.Text = "VID_273A PID_0131";
                    }
                    else if (nPort > 0)
                    {
                        s = "COM" + nPort.ToString() + ", baud = 115200";
                        lbPort.Text = s;
                    }
                    else
                    {
                        lbPort.Text = "Error: Connected HID Device Failed !!";
                        return;
                    }
                    break;

                case 1:		//Select HID Index in Device Manager
                case 2:		//Select HID Index in Device Manager
                case 3:		//Select HID Index in Device Manager
                case 4:		//Select HID Index in Device Manager
                     nPort = mPay_Connect(0, iSel-1);
                    if (nPort == -1)
                    {
                        lbPort.Text = "VID_273A PID_0131";
                    }
                    else
                    {
                        lbPort.Text = "Error: Connected HID Device Failed !!";
                        return;
                    }
                    break;

                default:	//Others: Select a COM Port
                    nPort = mPay_Connect(iSel-4, 0);
                    if (nPort > 0)
                    {
                        s = "COM" + nPort.ToString() + ", baud = 115200";
                        lbPort.Text = s;
                    }
                    else
                    {
                        lbPort.Text = "Error: Connected VCOM Device Failed !!";
                        return;
                    }
                    break;
            }

            // Get and show reader version string
            int iRet = 0;
            StringBuilder sVersion = new StringBuilder();
            sVersion.Capacity = 256;//设置字符串最大长度

            iRet = mPay_GetTerminalVersion(sVersion);
            lbFWVersion.Text += sVersion; // Firmware version string

            btConnect.Enabled = false;
            btDisconnect.Enabled = true;
            btPowerOn.Enabled = true;
            btPowerOff.Enabled = false;
            btSend.Enabled = false;
            cbCMD.SelectedIndex = 0;

            rbICCard_Click(sender, e);// Set IC Card as default.
        }

        private void btDisconnect_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            timer2.Enabled = false;
            mPay_Disconnect(cbPort.SelectedIndex - 1);
            lbPort.Text = "Port_State";
            lbFWVersion.Text = "Firmware Version: ";

            btConnect.Enabled = true;
            btDisconnect.Enabled = false;
            btPowerOn.Enabled = false;
            btPowerOff.Enabled = false;
            btSend.Enabled = false;
            btActivate.Enabled = false;
        }

        private void rbICCard_Click(object sender, EventArgs e)
        {
            csMessage = "";

            iSelectCardType = 0;
            rbICCard.Checked = true;
            rbSAMCard.Checked = false;
            rbPICC.Checked = false;
            rbMIFARE.Checked = false;

            csMessage = "<-- Select IC Card !!\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();

            btPowerOn.Enabled = true;
            btPowerOff.Enabled = false;
            btSend.Enabled = false;
            btActivate.Enabled = false;
        }

        private void rbSAMCard_Click(object sender, EventArgs e)
        {
            csMessage = "";

            iSelectCardType = 1;
            rbICCard.Checked = false;
            rbSAMCard.Checked = true;
            rbPICC.Checked = false;
            rbMIFARE.Checked = false;

            csMessage = "<-- Select SAM Card !!\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();

            btPowerOn.Enabled = true;
            btPowerOff.Enabled = false;
            btSend.Enabled = false;
            btActivate.Enabled = false;
        }

        private void rbPICC_Click(object sender, EventArgs e)
        {
            csMessage = "";

            iSelectCardType = 2;
            rbICCard.Checked = false;
            rbSAMCard.Checked = false;
            rbPICC.Checked = true;
            rbMIFARE.Checked = false;

            csMessage = "<-- Select PICC Card !!\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();

            btPowerOn.Enabled = true;
            btPowerOff.Enabled = false;
            btSend.Enabled = false;
            btActivate.Enabled = false;
        }

        private void rbMIFARE_Click(object sender, EventArgs e)
        {
            csMessage = "";

            iSelectCardType = 3;
            rbICCard.Checked = false;
            rbSAMCard.Checked = false;
            rbPICC.Checked = false;
            rbMIFARE.Checked = true;

            csMessage = "<-- Select MIFARE Card !!\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();

            btPowerOn.Enabled = false;
            btPowerOff.Enabled = false;
            btSend.Enabled = false;

            cbKeyType.SelectedIndex = 0;
            cbSector.SelectedIndex = 0;
            cbBlock.SelectedIndex = 0;

            btActivate.Enabled = true;
            btDeactivate.Enabled = false;
            btAuth.Enabled = false;
            btReadBlock.Enabled = false;
            btWriteBlock.Enabled = false;
            btIncrement.Enabled = false;
            btDecrement.Enabled = false;
        }

        private void btPowerOn_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            StringBuilder sATR = new StringBuilder();
            sATR.Capacity = 512;//设置字符串最大长度

            csMessage = csMessage + "<-- Press [Power On] button !!\r\n";

            if (iSelectCardType == 0) // IC Card
            {
                iRet = mPay_ICCPowerOn(sATR);
                if (iRet == 1)
                {
                    csMessage += "--> Got ATR: ";
                    csMessage += sATR;

                    btPowerOn.Enabled = false;
                    btPowerOff.Enabled = true;
                    btSend.Enabled = true;
                }
                else
                    csMessage += "--> Power On Test: Fail!!";
            }
            else if (iSelectCardType == 1) // SAM Card
            {
                iRet = mPay_SAMPowerOn(sATR);
                if (iRet == 1)
                {
                    csMessage += "--> Got ATR: ";
                    csMessage += sATR;

                    btPowerOn.Enabled = false;
                    btPowerOff.Enabled = true;
                    btSend.Enabled = true;
                }
                else
                    csMessage += "--> Power On Test: Fail!!";
            }
            else if (iSelectCardType == 2) // PICC Card
            {
                csMessage += "    Please put the PICC on the card reader...";
                timer1.Enabled = true; // Wait for user put a PICC card on the reader.
            }
            else
            {
                csMessage += "Unknown card";
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btPowerOff_Click(object sender, EventArgs e)
        {
            int iRet = 0;

            if (iSelectCardType == 0) // IC Card
            {
                iRet = mPay_ICCPowerOff();
                if (iRet == 1)
                    csMessage += "--> Power Off Test: Successful!!";
                else
                    csMessage += "--> Power Off Test: Fail!!";
            }
            else if (iSelectCardType == 1) // SAM Card
            {
                iRet = mPay_SAMPowerOff(); //Cancel previous working state
                if (iRet == 1)
                    csMessage += "--> Power Off Test: Successful!!";
                else
                    csMessage += "--> Power Off Test: Fail!!";
            }
            else if (iSelectCardType == 2) // PICC Card
            {
                iRet = mPay_PICCDeactivate();
                if (iRet == 1)
                    csMessage += "--> Power Off Test: Successful!!";
                else
                    csMessage += "--> Power Off Test: Fail!!";
            }
            else
                csMessage += "Unknown card";

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();

            btPowerOn.Enabled = true;
            btPowerOff.Enabled = false;
            btSend.Enabled = false;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;

            int iRet = 0;
            StringBuilder sCardNo = new StringBuilder();
            sCardNo.Capacity = 32;//设置字符串最大长度
            StringBuilder sATS = new StringBuilder();
            sATS.Capacity = 512;//设置字符串最大长度

            iRet = mPay_PICCActivate(sCardNo);
            if (iRet == 1)
            {
                csMessage += "--> Got Card Number: ";
                csMessage += sCardNo;
                csMessage = csMessage + "\r\n";

                iRet = mPay_PICCGetCardATS(sATS);
                if (iRet == 1)
                {
                    csMessage += "--> Got ATS: ";
                    csMessage += sATS;

                    btPowerOn.Enabled = false;
                    btPowerOff.Enabled = true;
                    btSend.Enabled = true;
                }
                else
                {
                    csMessage += "--> Get ATS Test: Fail!!";
                    mPay_PICCDeactivate();
                }
            }
            else
            {
                if (sCardNo.Length != 0)
                {
                    csMessage += "--> State: ";
                    csMessage += sCardNo;
                }
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btSend_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            string sCAPDU;
            StringBuilder sRAPDU = new StringBuilder();
            sRAPDU.Capacity = 1024;//设置字符串最大长度

            sCAPDU = cbCMD.Text;
            csMessage += "<-- Send Command: (" + sCAPDU + ")";
            csMessage = csMessage + "\r\n";
            csMessage += "--> R-APDU: ";

            if (iSelectCardType == 0) // IC Card
            {
                iRet = mPay_ICCSendApdu(sCAPDU, sRAPDU);
                if (iRet == 1)
                    csMessage += sRAPDU;
                else
                    csMessage += "--> Send APDU Test: Fail!!";
            }
            else if (iSelectCardType == 1) // SAM Card
            {
                iRet = mPay_SAMSendApdu(sCAPDU, sRAPDU);
                if (iRet == 1)
                    csMessage += sRAPDU;
                else
                    csMessage += "--> Send APDU Test: Fail!!";
            }
            else if (iSelectCardType == 2) // PICC Card
            {
                iRet = mPay_PICCSendApdu(sCAPDU, sRAPDU);
                if (iRet == 1)
                    csMessage += sRAPDU;
                else
                    csMessage += "--> Send APDU Test: Fail!!";
            }
            else
            {
                csMessage += "Unknown card";
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btActivate_Click(object sender, EventArgs e)
        {
            if (iSelectCardType == 3) // MIFARE Card
            {
                csMessage += "    Please put the MIFARE on the card reader...";
                timer2.Enabled = true; // Wait for user put a PICC card on the reader.
            }
            else
            {
                csMessage += "Unknown card";
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            timer2.Enabled = false;

            int iRet = 0;
            StringBuilder sCardNo = new StringBuilder();
            sCardNo.Capacity = 32;//设置字符串最大长度

            iRet = mPay_PICCActivate(sCardNo);
            if (iRet == 1)
            {
                csMessage += "--> Got Card Number: ";
                csMessage += sCardNo;

                btActivate.Enabled = false;
                btDeactivate.Enabled = true;
                btAuth.Enabled = true;
            }
            else
            {
                if (sCardNo.Length != 0)
                {
                    csMessage += "--> State: ";
                    csMessage += sCardNo;
                }
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btDeactivate_Click(object sender, EventArgs e)
        {
            int iRet = mPay_PICCDeactivate();
            if (iRet == 1)
                csMessage += "--> MIFARE Deactivate!!";
            else
                csMessage += "--> MIFARE Deactivate Fail!!";

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();

            btActivate.Enabled = true;
            btDeactivate.Enabled = false;
            btAuth.Enabled = false;
            btReadBlock.Enabled = false;
            btWriteBlock.Enabled = false;
            btIncrement.Enabled = false;
            btDecrement.Enabled = false;
        }

        private void btAuth_Click(object sender, EventArgs e)
        {
            int nKeyType = 0;
            if (cbKeyType.SelectedIndex == 0)
                nKeyType = 0x41;	//Key A
            else
                nKeyType = 0x42;	//Key B

            if (txKey.Text.Length < 12)
            {
                MessageBox.Show("Please key-in Auth Key 6 bytes (Hex format) in [Key] edit box !!");
                return;
            }

            int iRet = mPay_MifareAuth(nKeyType, cbSector.SelectedIndex, txKey.Text);
            if (iRet == 1)
            {
                csMessage += "--> Auth Key Pass!!";
                btAuth.Enabled = false;
                btReadBlock.Enabled = true;
                btWriteBlock.Enabled = true;
                btIncrement.Enabled = true;
                btDecrement.Enabled = true;
            }
            else
            {
                csMessage += "--> Auth Key Fail!!";
                btDeactivate_Click(sender, e);
                return;
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btReadBlock_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            StringBuilder sReadData = new StringBuilder();
            sReadData.Capacity = 32;//设置字符串最大长度
            int nBlock = cbSector.SelectedIndex * 4 + cbBlock.SelectedIndex;

            csMessage = csMessage + "<-- Read Block Data !!\r\n";
            iRet = mPay_MifareReadBlock(nBlock, sReadData);
            if (iRet == 1)
            {
                csMessage += "--> Got Block Data: ";
                csMessage += sReadData;
            }
            else
            {
                csMessage += "--> Read Block Data Fail!!\r\n";
                btDeactivate_Click(sender, e);
                return;
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btWriteBlock_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            int nBlock = cbSector.SelectedIndex * 4 + cbBlock.SelectedIndex;

            if (txWriteData.Text.Length < 32)
            {
                MessageBox.Show("Please key-in 16 bytes (Hex format) in [Write Dat] edit box !!");
                return;
            }

            csMessage = csMessage + "<-- Write Block Data!!\r\n";
            iRet = mPay_MifareWriteBlock(nBlock, txWriteData.Text);
            if (iRet == 1)
            {
                csMessage += "--> Write Block Data Pass!!";
            }
            else
            {
                csMessage += "--> Write Block Data Fail!!\r\n";
                btDeactivate_Click(sender, e);
                return;
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btIncrement_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            int nBlock = cbSector.SelectedIndex * 4 + cbBlock.SelectedIndex;

            if (txValue.Text.Length < 8)
            {
                MessageBox.Show("Please key-in 4 bytes (Hex format) in [Value] edit box !!");
                return;
            }

            csMessage = csMessage + "<-- Increment Value!!\r\n";
            iRet = mPay_MifareIncrement(nBlock, txValue.Text);
            if (iRet == 1)
            {
                csMessage += "--> Increment Value Pass!!";
            }
            else
            {
                csMessage += "--> Increment Value Fail!!\r\n";
                btDeactivate_Click(sender, e);
                return;
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }

        private void btDecrement_Click(object sender, EventArgs e)
        {
            int iRet = 0;
            int nBlock = cbSector.SelectedIndex * 4 + cbBlock.SelectedIndex;

            if (txWriteData.Text.Length < 8)
            {
                MessageBox.Show("Please key-in 4 bytes (Hex format) in [Value] edit box !!");
                return;
            }

            csMessage = csMessage + "<-- Decrement Value!!\r\n";
            iRet = mPay_MifareDecrement(nBlock, txValue.Text);
            if (iRet == 1)
            {
                csMessage += "--> Decrement Value Pass!!";
            }
            else
            {
                csMessage += "--> Decrement Value Fail!!\r\n";
                btDeactivate_Click(sender, e);
                return;
            }

            csMessage = csMessage + "\r\n";
            tbACK.Text = csMessage;
            tbACK.SelectionStart = tbACK.Text.Length;
            tbACK.ScrollToCaret();
        }




    }
}
