/*----------------------------------------------------------------------------------*/
/*	Function:  Sin HID & COM Series Interface Function								*/
/* 	Version:   V1.3											   					    */
/*	Last Date: 2017.05.02															*/
/* 	Author:    Pauline Ma										   					*/
/*----------------------------------------------------------------------------------*/


#ifndef _MPay_VC6_H_
#define _MPay_VC6_H_


extern "C" __declspec(dllexport) int __stdcall mPay_Connect(int iPortNo, int iHIDIndex);
extern "C" __declspec(dllexport) int __stdcall mPay_Disconnect(int iHIDIndex);
extern "C" __declspec(dllexport) int __stdcall mPay_GetTerminalVersion(char *sVersion);

extern "C" __declspec(dllexport) int __stdcall mPay_ICCPowerOn(char *ATR);
extern "C" __declspec(dllexport) int __stdcall mPay_ICCPowerOff();
extern "C" __declspec(dllexport) int __stdcall mPay_ICCSendApdu(char *cmd, char *recv);

extern "C" __declspec(dllexport) int __stdcall mPay_SAMPowerOn(char *ATR);
extern "C" __declspec(dllexport) int __stdcall mPay_SAMPowerOff();
extern "C" __declspec(dllexport) int __stdcall mPay_SAMSendApdu(char *cmd, char *recv);

extern "C" __declspec(dllexport) int __stdcall mPay_PICCActivate(char *cardNo);
extern "C" __declspec(dllexport) int __stdcall mPay_PICCDeactivate();
extern "C" __declspec(dllexport) int __stdcall mPay_PICCGetCardATS(char *ATS);
extern "C" __declspec(dllexport) int __stdcall mPay_PICCSendApdu(char *cmd, char *recv);

extern "C" __declspec(dllexport) int __stdcall mPay_MifareAuth(int KeyType, int Sector, char *Key);
extern "C" __declspec(dllexport) int __stdcall mPay_MifareReadBlock(int Block, char *ReadData);
extern "C" __declspec(dllexport) int __stdcall mPay_MifareWriteBlock(int Block, char *WriteData);
extern "C" __declspec(dllexport) int __stdcall mPay_MifareIncrement(int Block, char *Value);
extern "C" __declspec(dllexport) int __stdcall mPay_MifareDecrement(int Block, char *Value);


#endif // #ifndef _MPay_VC6_H_