

#import "BleSubMifareViewController.h"

@interface BleSubMifareViewController ()

@end

@implementation BleSubMifareViewController

@synthesize txtBleSubMifareMsg;
@synthesize btnPicker_KeyType;
@synthesize btnPicker_Sector;
@synthesize btnPicker_Block;
@synthesize txtAuth;
@synthesize txtWrite;
@synthesize txtIncDec;

- (IBAction)btnActive_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfActivateCard])
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Activation..."];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnDeactive_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfDeactivateCard])
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Deactivation..."];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnAuthCard_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfMifareAuthCard:[NSString stringWithFormat:@"%02lx",(long)btnPicker_KeyType.tag]
                          sData:[NSString stringWithFormat:@"%02lx",(long)btnPicker_Sector.tag]
                          sData:[NSString stringWithFormat:@"%@",txtAuth.text]])
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Auth Card..."];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnRead_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfMifareReadBlock:[NSString stringWithFormat:@"%02lx", (long)((btnPicker_Sector.tag * 4) + btnPicker_Block.tag)]])
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Read Block..."];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnWrite_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfMifareWriteBlock:[NSString stringWithFormat:@"%02lx", (long)((btnPicker_Sector.tag * 4) + btnPicker_Block.tag)]
                            sData:[NSString stringWithFormat:@"%@", txtWrite.text]])
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Write Block..."];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}
- (IBAction)btnInc_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfMifareIncrement:[NSString stringWithFormat:@"%02lx", (long)((btnPicker_Sector.tag * 4) + btnPicker_Block.tag)]
                           sData:[NSString stringWithFormat:@"%@", txtIncDec.text]])
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Inc Value..."];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnDec_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfMifareDecrement:[NSString stringWithFormat:@"%02lx", (long)((btnPicker_Sector.tag * 4) + btnPicker_Block.tag)]
                           sData:[NSString stringWithFormat:@"%@", txtIncDec.text]])
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Dec Value..."];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

-(IBAction) btnPicker_KeyType_OnTouch:(id)sender
{
    UIActionSheet *act = [[UIActionSheet alloc] initWithTitle:@"Key Type"
                                                     delegate:self
                                            cancelButtonTitle:nil
                                       destructiveButtonTitle:nil
                                            otherButtonTitles:nil];
    
    for (int i = 0; i < [aryPicker_KeyType count]; i++)
    {
        [act addButtonWithTitle:[aryPicker_KeyType objectAtIndex:i]];
    }
    
    [act addButtonWithTitle:@"Cancel"];
    act.cancelButtonIndex = [aryPicker_KeyType count];
    act.tag = 0;
    
    act.actionSheetStyle = UIActionSheetStyleAutomatic;
    [act showInView:self.view];
}

-(IBAction) btnPicker_Block_OnTouch:(id)sender
{
    UIActionSheet *act = [[UIActionSheet alloc] initWithTitle:@"Block"
                                                     delegate:self
                                            cancelButtonTitle:nil
                                       destructiveButtonTitle:nil
                                            otherButtonTitles:nil];
    
    for (int i = 0; i < [aryPicker_Block count]; i++)
    {
        [act addButtonWithTitle:[aryPicker_Block objectAtIndex:i]];
    }
    
    [act addButtonWithTitle:@"Cancel"];
    act.cancelButtonIndex = [aryPicker_Block count];
    act.tag = 1;
    
    act.actionSheetStyle = UIActionSheetStyleAutomatic;
    [act showInView:self.view];
}

-(IBAction) btnPicker_Sector_OnTouch:(id)sender
{
    UIActionSheet *act = [[UIActionSheet alloc] initWithTitle:@"Sector"
                                                     delegate:self
                                            cancelButtonTitle:nil
                                       destructiveButtonTitle:nil
                                            otherButtonTitles:nil];
    
    for (int i = 0; i < [aryPicker_Sector count]; i++)
    {
        [act addButtonWithTitle:[aryPicker_Sector objectAtIndex:i]];
    }
    
    [act addButtonWithTitle:@"取消"];
    act.cancelButtonIndex = [aryPicker_Sector count];
    act.tag = 2;
    
    act.actionSheetStyle = UIActionSheetStyleAutomatic;
    [act showInView:self.view];
}

- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex
{
    switch (actionSheet.tag)
    {
        case 0:
            // KeyType
            if (buttonIndex < [aryPicker_KeyType count])
            {
                if ([[aryPicker_KeyType objectAtIndex:buttonIndex] isEqual: @"A"])
                {
                    [btnPicker_KeyType setTitle:@"Key Type:A" forState:UIControlStateNormal];
                    btnPicker_KeyType.tag = 65;
                }
                else
                {
                    [btnPicker_KeyType setTitle:@"Key Type:B" forState:UIControlStateNormal];
                    btnPicker_KeyType.tag = 66;
                }
            }
            break;
        case 1:
            // Block
            if (buttonIndex < [aryPicker_Block count])
            {
                [btnPicker_Block setTitle:[NSString stringWithFormat:@"Block:%@", [aryPicker_Block objectAtIndex:buttonIndex]] forState:UIControlStateNormal];
                btnPicker_Block.tag = buttonIndex;
            }
            break;
        case 2:
            // Sector
            if (buttonIndex < [aryPicker_Sector count])
            {
                [btnPicker_Sector setTitle:[NSString stringWithFormat:@"Sector:%@", [aryPicker_Sector objectAtIndex:buttonIndex]] forState:UIControlStateNormal];
                btnPicker_Sector.tag = buttonIndex;
            }
            break;
    }
}

#pragma mark - delegate control

- (void)onMPayBleResponse_Error:(int)iErrorCode Message:(NSString*)sMessage
{
    txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Fail\n"];
    [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    
    txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Return->ErrorCode:%i MSG:%@\n", iErrorCode, sMessage];
    [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
}

- (void)onMPayBleResponse_IsConnected:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed!\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
    else
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Fail!\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_UpdateState:(int)iStateCode Message:(NSString*)sMessage
{
    txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Ble Update State: %@", sMessage];
    [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    
//    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Ble Update State"
//                                                    message:sMessage
//                                                   delegate:nil
//                                          cancelButtonTitle:@"OK" otherButtonTitles:nil];
//    [alert show];
}

- (void)onMPayBleResponse_PiccActivation:(BOOL)bSucceed SerialNumber:(NSString*)sSerialNumber
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
        
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"SerialNumber->%@\n", sSerialNumber];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_MifareAuth:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_MifareReadBlock:(BOOL)bSucceed sData:(NSString*)sData
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
        
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Data->%@\n", sData];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_MifareWriteBlock:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_MifareIncrement:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_MifareDecrement:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_PiccDeactivation:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubMifareMsg.text = [txtBleSubMifareMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubMifareMsg scrollRangeToVisible:NSMakeRange(txtBleSubMifareMsg.text.length - 1, 0)];
    }
}

#pragma mark - ViewController Basic

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:(BOOL)animated];
    
    smPayBleLib.delegate = self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    aryPicker_KeyType= [[NSMutableArray alloc] init];
    [aryPicker_KeyType addObject:@"A"];
    [aryPicker_KeyType addObject:@"B"];
    
    aryPicker_Sector = [[NSMutableArray alloc] init];
    for (int i = 0; i < 16; i++) { [aryPicker_Sector addObject:[NSString stringWithFormat:@"%02x", i]]; }
    
    aryPicker_Block = [[NSMutableArray alloc] init];
    for (int i = 0; i < 4; i++) { [aryPicker_Block addObject:[NSString stringWithFormat:@"%02x", i]]; }
    
    btnPicker_KeyType.tag = 65;
    btnPicker_Sector.tag = 0;
    btnPicker_Block.tag = 0;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
