

#import "BleSubPiccViewController.h"

@interface BleSubPiccViewController ()

@end

@implementation BleSubPiccViewController

@synthesize txtBleSubPiccMsg;
@synthesize txtPiccData;

- (IBAction)btnActive_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfActivateCard])
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Active..."];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnDeactive_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfDeactivateCard])
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Deactive..."];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnRFRate_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfRateCard])
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"RF Rate..."];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnRFAccess_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_RfAccessCard:txtPiccData.text])
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"RF Access..."];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnRFGetCardHolder_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_IccGetCardHolder])
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"RF Get Info..."];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

#pragma mark - delegate control

- (void)onMPayBleResponse_Error:(int)iErrorCode Message:(NSString*)sMessage
{
    txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Fail\n"];
    [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    
    txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Return->ErrorCode:%i MSG:%@\n", iErrorCode, sMessage];
    [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
}

- (void)onMPayBleResponse_IsConnected:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Succeed!\n"];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
    else
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Fail!\n"];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_UpdateState:(int)iStateCode Message:(NSString*)sMessage
{
    txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Ble Update State: %@", sMessage];
    [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    
//    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Ble Update State"
//                                                    message:sMessage
//                                                   delegate:nil
//                                          cancelButtonTitle:@"OK" otherButtonTitles:nil];
//    [alert show];
}

- (void)onMPayBleResponse_PiccActivation:(BOOL)bSucceed SerialNumber:(NSString*)sSerialNumber
{
    if( bSucceed )
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
        
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"SerialNumber->%@\n", sSerialNumber];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_PiccRate:(BOOL)bSucceed Ats:(NSString*)sAts
{
    if( bSucceed )
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
        
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Ats->%@\n", sAts];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_PiccAccess:(BOOL)bSucceed Rapdu:(NSString*)sRapdu
{
    if( bSucceed )
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
        
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Rapdu->%@\n", sRapdu];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_IccGetCardholder:(BOOL)bSucceed CardNumber:(NSString*)sCardNumber CardHolderName:(NSString*)sCardHolderName Date:(NSString*)sDate
{
    if( bSucceed )
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
        
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"CardNumber->%@\nCardHolderName->%@\nDate->%@\n", sCardNumber, sCardHolderName, sDate];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_PiccDeactivation:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleSubPiccMsg.text = [txtBleSubPiccMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleSubPiccMsg scrollRangeToVisible:NSMakeRange(txtBleSubPiccMsg.text.length - 1, 0)];
    }
}
#pragma mark - ViewController Basic

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:(BOOL)animated];
    
    smPayBleLib.delegate = self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

//
//  Set Screen Auto Rotation
//
- (BOOL)shouldAutorotate {
    return YES;
}

//- (NSUInteger)supportedInterfaceOrientations
- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
    return UIInterfaceOrientationMaskAll;
}

//
// Set Keyboare when touch screen return method
//
-(BOOL)textFieldShouldReturn:(UITextField *)theTextField
{
    if (theTextField == txtPiccData){
        [txtPiccData resignFirstResponder];
    }
    return YES;
}

//
// Set Keyboare when touch "Enter" return method
//
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [txtBleSubPiccMsg resignFirstResponder];
    [txtPiccData resignFirstResponder];
}

@end
