


#import "BleTableViewController.h"

@interface BleTableViewController ()
{}
@end

@implementation BleTableViewController
{}

@synthesize refreshControl;

//
//  Set Screen Auto Rotation
//
- (BOOL)shouldAutorotate {
    return YES;
}

//- (NSUInteger)supportedInterfaceOrientations
- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
    return UIInterfaceOrientationMaskAll;
}

#pragma mark - SBReaderLib Delegate

- (void)onMPayBleResponse_Error:(int)iErrorCode Message:(NSString*)sMessage
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ERROR"
                                                    message:sMessage
                                                   delegate:nil
                                          cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

- (void)onMPayBleResponse_UpdateState:(int)iStateCode Message:(NSString*)sMessage
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Ble Update State"
                                                    message:sMessage
                                                   delegate:nil
                                          cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

- (void)onMPayBleResponse_GetDevice:(BOOL)bSucceed peripheral:(CBPeripheral *)peripheral;
{
    if (bSucceed)
    {
//        NSLog(@"Get Device: %@ %@", peripheral.name, peripheral.UUID);
        [PeripheralArray addObject:peripheral];
        [self.tableView reloadData];
    }
}

#pragma mark - Table view controller

- (void)viewWillAppear:(BOOL)animated
{
    smPayBleLib.delegate = self;
    
    [PeripheralArray removeAllObjects];
    
    [self startScanDevice];
}

//
// 下拉更新之後要做的事.
//
-(void) refreshTableView
{
    // 清除 Array 所有物件
    [PeripheralArray removeAllObjects];
    
    // 重新掃描 device
    [smPayBleLib mPayBle_StopSearching];
    [smPayBleLib mPayBle_SearchDevice];
    
    [self.tableView reloadData];
    
    // 結束更新
    [self.refreshControl endRefreshing];
}

- (void)viewDidLoad {
    
    [super viewDidLoad];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
    
    smPayBleLib = [[MPayBleLib alloc] init];
    PeripheralArray = [[NSMutableArray alloc] init];
    
    // 建立下拉更新的subview
    self.refreshControl = [[UIRefreshControl alloc] init];
    [self.refreshControl addTarget:self action:@selector(refreshTableView) forControlEvents:UIControlEventValueChanged];
    [self.tbView addSubview:self.refreshControl];
    //[self setTitle:@"Scanning Device"];
}

- (void)startScanDevice
{
    [smPayBleLib mPayBle_DisconnectDevice];
    [smPayBleLib mPayBle_SearchDevice];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

//
// 把資料傳送到下一個 ViewController
//
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    // 停止掃描
    [smPayBleLib mPayBle_StopSearching];
    
    // 取得下一個 ViewController 實體
    //id nextViewController = segue.destinationViewController;
    UIViewController *nextViewController = segue.destinationViewController;
    
    //利用index取得陣列內的物件
    //NSIndexPath *path = [self.tableView indexPathForSelectedRow];
    NSIndexPath *path = [self.tableView indexPathForCell:sender];
    
    CBPeripheral *peripheralTmp = [PeripheralArray objectAtIndex:path.row];
    
    // 設定要傳送的值
    [nextViewController setValue:peripheralTmp forKeyPath:@"ChoicePeripheral"];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
//#warning Potentially incomplete method implementation.
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
//#warning Incomplete method implementation.
    // Return the number of rows in the section.
    //return 0;
    return [PeripheralArray count];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {

    //製作可重複利用的表格欄位Cell
    static NSString *DeviceIdentifier = @"DeviceIdentifier";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:DeviceIdentifier forIndexPath:indexPath];
    
    // Configure the cell...
    if (cell == nil)
    {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:DeviceIdentifier];
    }
    
    //設定欄位的內容與類型
    CBPeripheral *peripheralTmp = [PeripheralArray objectAtIndex:indexPath.row];
    cell.textLabel.text = peripheralTmp.name;
    
    //cell.textLabel.text = [NameArray objectAtIndex:indexPath.row];
    //cell.textLabel.text = [roleArray objectAtIndex:indexPath.row];
    //cell.textLabel.text = [[heroicaArray objectAtIndex:indexPath.section] objectAtIndex:indexPath.row];
    cell.accessoryType = UITableViewCellAccessoryDetailDisclosureButton;
    
    return cell;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    //    NSUInteger row = [indexPath row];
    //    NSString *rowValue = [PeripheralArray objectAtIndex:row]; //用 NSString 去記錄使用者點選的 row
    //    NSString *message = [[NSString alloc] initWithFormat:@"you pressed row %@",rowValue];
    //    //用一個 alert 去告訴使用者現在正在點選的 Row
    //    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ROW SELECTED" message:message delegate:nil cancelButtonTitle:@"I GOT IT" otherButtonTitles:nil];
    //    [alert show];
    //    //讓選取的效果消失
    //    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    // 停止掃描
    [smPayBleLib mPayBle_StopSearching];
    
    //透過標簽取得目標實體
    
    BleViewController *detailView = [self.storyboard instantiateViewControllerWithIdentifier:@"BleView"];
    //切換畫面
    [self.navigationController pushViewController:detailView animated:YES];
    //傳遞參數
    [detailView setDetailItem:[PeripheralArray objectAtIndex:indexPath.row]];
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    } else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
