


#import "BleViewController.h"

@interface BleViewController ()

@end

@implementation BleViewController
{}

@synthesize txtBleMsg;
@synthesize txtTerminalSn;
@synthesize txtTimer;
@synthesize btnDemo;
@synthesize ChoicePeripheral;


//
// Get data from TableView
//
- (void)setDetailItem:(CBPeripheral *)newDetailItem
{
    ChoicePeripheral = newDetailItem;
}

#pragma mark - UI View Control

- (IBAction)btnGetVersion_OnTouch:(id)sender
{
    if( [smPayBleLib mPayBle_GetReaderVersion] )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Get Version..."];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnGetBattery_OnTouch:(id)sender
{
    if ([smPayBleLib mPayBle_GetBattery])
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Get Battery..."];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnSetSleepTimer_OnTouch:(id)sender
{
    if( [smPayBleLib mPayBle_SetSleepTimer:[NSString stringWithFormat:@"%@",txtTimer.text]] )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Set Sleep Timer..."];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnGetTerminalSn_OnTouch:(id)sender
{
    if( [smPayBleLib mPayBle_GetTerminalSn] )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Get Terminal Sn..."];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
}

- (IBAction)btnSetTerminalSn_OnTouch:(id)sender
{
    if( [smPayBleLib mPayBle_SetTerminalSn:[NSString stringWithFormat:@"%@",txtTerminalSn.text]] )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Set Terminal Sn..."];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
}

#pragma mark - SBReaderLib deleaget

- (void)onMPayBleResponse_IsConnected:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Ble Connection Succeed!\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        
        btnDemo.enabled = TRUE;
    }
    else
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Fail!\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_UpdateState:(int)iStateCode Message:(NSString*)sMessage
{
    txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Ble Update State: %@", sMessage];
    [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    
//    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Ble Update State"
//                                                    message:sMessage
//                                                   delegate:nil
//                                          cancelButtonTitle:@"OK" otherButtonTitles:nil];
//    [alert show];
}

- (void)onMPayBleResponse_GetVersionString:(BOOL)bSucceed sMessage:(NSString*)sMessage
{
    if( bSucceed )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        
        if (![sMessage isEqualToString:@""])
        {
            txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Return->%@\n", sMessage];
            [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        }
    }
}

- (void)onMPayBleResponse_GetBattery:(BOOL)bSucceed battery:(NSString*)sBattery
{
    if( bSucceed )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        
        if (![sBattery isEqualToString:@""])
        {
            txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Return->%@\n", sBattery];
            [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        }
    }
}

- (void)onMPayBleResponse_SetSleepTimer:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Succeed!\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
    else
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Fail!\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }
}

- (void)onMPayBleResponse_GetTerminalSn:(BOOL)bSucceed
                               sMessage:(NSString*)sMessage
{
    if( bSucceed )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Succeed\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        
        if (![sMessage isEqualToString:@""])
        {
            txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Return->%@\n", sMessage];
            [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        }
    }
}

- (void)onMPayBleResponse_SetTerminalSn:(BOOL)bSucceed
{
    if( bSucceed )
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Succeed!\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
        
        btnDemo.enabled = TRUE;
    }
    else
    {
        txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Fail!\n"];
        [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    }

}

- (void)onMPayBleResponse_Error:(int)iErrorCode Message:(NSString*)sMessage
{
//    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ERROR"
//                                                    message:sMessage
//                                                   delegate:nil
//                                          cancelButtonTitle:@"OK" otherButtonTitles:nil];
//    [alert show];
}

#pragma mark - ViewController Basic

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:(BOOL)animated];
    
    smPayBleLib.delegate = self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Do any additional setup after loading the view.
//    txtBleMsg.text = [txtBleMsg.text stringByAppendingFormat:@"Connecting..."];
//    [txtBleMsg scrollRangeToVisible:NSMakeRange(txtBleMsg.text.length - 1, 0)];
    
    
    NSLog( @"Choice: %@", ChoicePeripheral.name );
    
    // Connect Peripheral
    [smPayBleLib mPayBle_ConnectDevice:ChoicePeripheral];
    
    
    btnDemo.enabled = FALSE;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

//
//  Set Screen Auto Rotation
//
- (BOOL)shouldAutorotate {
    return YES;
}

//- (NSUInteger)supportedInterfaceOrientations
- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
    return UIInterfaceOrientationMaskAll;
}

//
// Set Keyboare when touch screen return method
//
-(BOOL)textFieldShouldReturn:(UITextField *)theTextField
{
    //    if (theTextField == txtTerminalParameter){
    //        [txtTerminalParameter resignFirstResponder];
    //    }
    return YES;
}

//
// Set Keyboare when touch "Enter" return method
//
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [txtBleMsg resignFirstResponder];
    //    [txtTerminalParameter resignFirstResponder];
}

@end
